// #### Uncomment the next two lines (in increasing verbose order)
// #### for debugging info
// #define PERLWIN32GUI_DEBUG
// #define PERLWIN32GUI_STRONGDEBUG

#define  WIN32_LEAN_AND_MEAN
#define _WIN32_IE 0x0401
#define _WIN32_WINNT 0x0400
#undef NOTRACKMOUSEEVENT
#include <stdarg.h>
#include <windows.h>
#include <winuser.h>
#include <commctrl.h>
#include <commdlg.h>
#include <wtypes.h>
#include <richedit.h>
#include <shellapi.h>
#include <shlobj.h>

// #include <ctl3d.h>

#include "resource.h"

#define __TEMP_WORD  WORD   /* perl defines a WORD, yikes! */

/*
 * Perl includes
 */
#if defined(__cplusplus) && !defined(PERL_OBJECT) && !defined(PERL_IMPLICIT_CONTEXT)
extern "C" {
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#if defined(__cplusplus) && !defined(PERL_OBJECT) && !defined(PERL_IMPLICIT_CONTEXT)
}
#endif

#define MAX_WINDOW_NAME 128
#define MAX_EVENT_NAME 255

#define WM_EXITLOOP   (WM_APP+1)    /* custom message to exit from the Dialog() function */
#define WM_NOTIFYICON (WM_APP+2)    /* custom message to process NotifyIcon events */

#define PERLWIN32GUI_DIALOGUI				0x0001
#define PERLWIN32GUI_TRACKING				0x0002
#define PERLWIN32GUI_HORIZONTAL				0x0004
#define PERLWIN32GUI_CHECKED				0x0008
#define PERLWIN32GUI_SEENCHECKED			0x0010
#define PERLWIN32GUI_CONTAINER				0x0020

#define PERLWIN32GUI_NEM					0x2000
#define PERLWIN32GUI_NEM_PARENT				0x4000
#define PERLWIN32GUI_NEM_CHILD				0x8000

#define PERLWIN32GUI_NEM_MOUSEMOVE			0x00000001
#define PERLWIN32GUI_NEM_MOUSEDOWN			0x00000002
#define PERLWIN32GUI_NEM_MOUSEUP			0x00000004
#define PERLWIN32GUI_NEM_KEYDOWN			0x00000008
#define PERLWIN32GUI_NEM_KEYUP				0x00000010
#define PERLWIN32GUI_NEM_CLICK				0x00000020
#define PERLWIN32GUI_NEM_DBLCLICK			0x00000040
#define PERLWIN32GUI_NEM_GOTFOCUS			0x00000080
#define PERLWIN32GUI_NEM_LOSTFOCUS			0x00000100

#define PERLWIN32GUI_NEM_DEACTIVATE			0x10000001
#define PERLWIN32GUI_NEM_ACTIVATE			0x10000002
#define PERLWIN32GUI_NEM_TERMINATE			0x10000004
#define PERLWIN32GUI_NEM_MINIMIZE			0x10000008
#define PERLWIN32GUI_NEM_MAXIMIZE			0x10000010
#define PERLWIN32GUI_NEM_RESIZE				0x10000020

#define PERLWIN32GUI_NEM_CHANGE				0x00000200
#define PERLWIN32GUI_NEM_CHANGING			0x00000400
#define PERLWIN32GUI_NEM_ITEMCLICK			0x00000800
#define PERLWIN32GUI_NEM_BUTTONCLICK		0x00001000
#define PERLWIN32GUI_NEM_COLUMNCLICK		0x00002000
#define PERLWIN32GUI_NEM_COLLAPSE			0x00004000
#define PERLWIN32GUI_NEM_EXPAND				0x00008000
#define PERLWIN32GUI_NEM_COLLAPSING			0x00010000
#define PERLWIN32GUI_NEM_EXPANDING			0x00020000
#define PERLWIN32GUI_NEM_NODECLICK			0x00040000
#define PERLWIN32GUI_NEM_NEEDTEXT			0x00080000
#define PERLWIN32GUI_NEM_HEIGHTCHANGE		0x00100000
#define PERLWIN32GUI_NEM_BEGINTRACK			0x00200000
#define PERLWIN32GUI_NEM_ENDTRACK			0x00400000
#define PERLWIN32GUI_NEM_TRACK				0x00800000
#define PERLWIN32GUI_NEM_DIVIDERDBLCLICK	0x01000000
#define PERLWIN32GUI_NEM_ITEMDBLCLICK		0x02000000
#define PERLWIN32GUI_NEM_ITEMCHECK			0x04000000

#define PERLWIN32GUI_ARGTYPE_INT			0x0001
#define PERLWIN32GUI_ARGTYPE_LONG			0x0002
#define PERLWIN32GUI_ARGTYPE_WORD			0x0004
#define PERLWIN32GUI_ARGTYPE_STRING			0x0008

#define PERLWIN32GUI_EM_BYNAME				0x0000
#define PERLWIN32GUI_EM_BYREF				0x0001
#define PERLWIN32GUI_EM_BOTH				0x0002

/*
 * object types (for switch()ing)
 */
#define WIN32__GUI__WINDOW      0
#define WIN32__GUI__DIALOG      1

#define WIN32__GUI__STATIC      11
#define WIN32__GUI__BUTTON      12
#define WIN32__GUI__EDIT        13
#define WIN32__GUI__LISTBOX     14
#define WIN32__GUI__COMBOBOX    15

#define WIN32__GUI__CHECKBOX    21
#define WIN32__GUI__RADIOBUTTON 22
#define WIN32__GUI__GROUPBOX    23

#define WIN32__GUI__TOOLBAR     30
#define WIN32__GUI__PROGRESS    31
#define WIN32__GUI__STATUS      32
#define WIN32__GUI__TAB         33
#define WIN32__GUI__RICHEDIT    34
#define WIN32__GUI__LISTVIEW    35
#define WIN32__GUI__TREEVIEW    36
#define WIN32__GUI__TRACKBAR    37
#define WIN32__GUI__UPDOWN      38
#define WIN32__GUI__TOOLTIP     39
#define WIN32__GUI__ANIMATION   40
#define WIN32__GUI__REBAR       41
#define WIN32__GUI__HEADER      42
#define WIN32__GUI__COMBOBOXEX  43
#define WIN32__GUI__DTPICK      44

#define WIN32__GUI__GRAPHIC    101
#define WIN32__GUI__SPLITTER   102
#define WIN32__GUI__MDICLIENT  103

#define PERLWIN32GUI_CLS_WINDOW      0
#define PERLWIN32GUI_CLS_DIALOG      1

#define PERLWIN32GUI_CLS_STATIC      11
#define PERLWIN32GUI_CLS_BUTTON      12
#define PERLWIN32GUI_CLS_EDIT        13
#define PERLWIN32GUI_CLS_LISTBOX     14
#define PERLWIN32GUI_CLS_COMBOBOX    15

#define PERLWIN32GUI_CLS_CHECKBOX    21
#define PERLWIN32GUI_CLS_RADIOBUTTON 22
#define PERLWIN32GUI_CLS_GROUPBOX    23

#define PERLWIN32GUI_CLS_TOOLBAR     30
#define PERLWIN32GUI_CLS_PROGRESS    31
#define PERLWIN32GUI_CLS_STATUS      32
#define PERLWIN32GUI_CLS_TAB 		 33
#define PERLWIN32GUI_CLS_RICHEDIT    34
#define PERLWIN32GUI_CLS_LISTVIEW    35
#define PERLWIN32GUI_CLS_TREEVIEW    36
#define PERLWIN32GUI_CLS_TRACKBAR    37
#define PERLWIN32GUI_CLS_UPDOWN      38
#define PERLWIN32GUI_CLS_TOOLTIP     39
#define PERLWIN32GUI_CLS_ANIMATION   40
#define PERLWIN32GUI_CLS_REBAR       41
#define PERLWIN32GUI_CLS_HEADER      42
#define PERLWIN32GUI_CLS_COMBOBOXEX  43
#define PERLWIN32GUI_CLS_DTPICK      44

#define PERLWIN32GUI_CLS_GRAPHIC    101
#define PERLWIN32GUI_CLS_SPLITTER   102
#define PERLWIN32GUI_CLS_MDICLIENT  103


/*
 * Various definitions to accomodate the different Perl versions around
 */
#ifdef PERL_OBJECT
#   ifdef _INC_WIN32_PERL5
#       pragma message( "\n*** Using the 5.005 Perl Object CPerlObj class.\n" )
#       define NOTXSPROC   CPerlObj *pPerl,
#       define NOTXSCALL   pPerl,
#       define CPerl CPerlObj
#   else // not _INC_WIN32_PERL5
#       pragma message( "\n*** Using the 5.004 Perl Object CPerl class.\n" )
#       define NOTXSPROC   CPerl *pPerl,
#       define NOTXSCALL   pPerl,
#   endif  //  _INC_WIN32_PERL5
#else
#   pragma message( "\n*** Using a non-Object Core Perl.\n" )
#   define NOTXSPROC
#   define NOTXSCALL
#endif

/*
 * an extension to Window's CREATESTRUCT structure
 */
typedef struct tagPERLWIN32GUI_CREATESTRUCT {
    CREATESTRUCT cs;
    /*
    CREATESTRUCT has the following members:
        LPVOID      lpCreateParams;
        HINSTANCE   hInstance;
        HMENU       hMenu;
        HWND        hwndParent;
        int         cy;
        int         cx;
        int         y;
        int         x;
        LONG        style;
        LPCTSTR     lpszName;
        LPCTSTR     lpszClass;
        DWORD       dwExStyle;
    */
    HIMAGELIST  hImageList;
    HV*         hvParent;
    HV*         hvSelf;
    char *      szWindowName;
    char *      szWindowFunction;
    HFONT       hFont;
    int         iClass;
	HACCEL		hAcc;
	HWND		hTooltip;
	HCURSOR		hCursor;
	char *		szTip;
	DWORD		dwPlStyle;
	int			iMinWidth;
	int			iMaxWidth;
	int			iMinHeight;
	int			iMaxHeight;
	COLORREF	clrForeground;
	COLORREF	clrBackground;
	HBRUSH		hBackgroundBrush;
	int			iEventModel;
	HV*			hvEvents;
	DWORD		dwEventMask;
} PERLWIN32GUI_CREATESTRUCT, *LPPERLWIN32GUI_CREATESTRUCT;

/*
 * what we'll store in GWL_USERDATA
 */
typedef struct tagPERLWIN32GUI_USERDATA {
	DWORD 		dwSize;							// struct size (our signature)
#ifdef PERL_OBJECT
	CPerl   	*pPerl; 						// a pointer to the Perl Object
#endif
	SV*			svSelf;							// a pointer to ourself
	char 		szWindowName[MAX_WINDOW_NAME];	// our -name
	BOOL		fDialogUI;						// are we to intercept dialog messages?
	int			iClass;							// our (Perl) class
	HACCEL		hAcc;							// our accelerator table
	HWND		hTooltip;
	HCURSOR		hCursor;
	DWORD		dwPlStyle;
	int			iMinWidth;
	int			iMaxWidth;
	int			iMinHeight;
	int			iMaxHeight;
	COLORREF	clrForeground;
	COLORREF	clrBackground;
	HBRUSH		hBackgroundBrush;
	WNDPROC		wndprocPreContainer;
	WNDPROC		wndprocPreNEM;
	int			iEventModel;
	HV*			hvEvents;
	DWORD		dwEventMask;
	HWND		Modal;
} PERLWIN32GUI_USERDATA, *LPPERLWIN32GUI_USERDATA;

typedef struct tagPERLWIN32GUI_MENUITEMDATA {
	DWORD		dwSize;
	char		szName[MAX_WINDOW_NAME];
	SV*			svCode;
} PERLWIN32GUI_MENUITEMDATA, *LPPERLWIN32GUI_MENUITEMDATA;

typedef struct tagPERLWIN32GUI_WINPROCS {
	HWND 		hWnd;
	WNDPROC		wndProc;
} PERLWIN32GUI_WINPROCS, *LPPERLWIN32GUI_WINPROCS;

#define ValidUserData(ptr) (ptr != NULL && ptr->dwSize == sizeof(PERLWIN32GUI_USERDATA))

#define HV_SELF_FROM_WINDOW(x) (SV_SELF_FROM_WINDOW(x) ? (HV*)SvRV(SV_SELF_FROM_WINDOW(x)) : NULL)

#undef WORD
#define WORD __TEMP_WORD

/*
 * Section for the constant definitions.
 */
#define CROAK croak


/*
 * some Perl macros for backward compatibility
 */
#ifndef SvIV
#	define SvIV(sv) (SvIOK(sv) ? SvIVX(sv) : sv_2iv(sv))
#endif

#ifndef SvPV
#	define SvPV(sv, lp) (SvPOK(sv) ? ((lp = SvCUR(sv)), SvPVX(sv)) : sv_2pv(sv, &lp))
#endif

#ifndef SvPV_nolen
#	define SvPV_nolen(sv) SvPV(sv, PL_na)
#endif

#define PERLPUSHMARK(p) if (++markstack_ptr == markstack_max)   \
    markstack_grow();           \
    *markstack_ptr = (p) - stack_base

#define PERLXPUSHs(s)   do {\
    if (stack_max - sp < 1) {\
        sp = stack_grow(sp, sp, 1);\
    }\
    (*++sp = (s)); } while (0)

#ifdef NT_BUILD_NUMBER
#   ifndef dowarn
#       define dowarn FALSE
#   endif
#endif

#ifndef call_sv
#	define call_sv	perl_call_sv
#endif

/*
 * other useful things
 */
#define SwitchBit(mask, bit, set) \
    if(set == 0) { \
        if(mask & bit) { \
            mask ^= bit; \
        } \
    } else { \
        if(!(mask & bit)) { \
            mask |= bit; \
        } \
    }

#define BitmaskOption(string, mask, bit) \
    if(strcmp(option, string) == 0) { \
        next_i = i + 1; \
        SwitchBit(mask, bit, SvIV(ST(next_i)));

#define BitmaskOptionValue(string, mask, bit) \
    if(strcmp(option, string) == 0) { \
		retval = TRUE; \
        SwitchBit(mask, bit, SvIV(value));


/* prototypes */

/* GUI_Constants.cpp */
DWORD constant(NOTXSPROC char *name, int arg);

/* GUI_Helpers.cpp */
#ifdef PERL_OBJECT
CPerl *	PERL_OBJECT_FROM_WINDOW(HWND hwnd);
#endif
SV * SV_SELF_FROM_WINDOW(HWND hwnd);
static void hv_magic_check (NOTXSPROC HV *hv, bool *needs_copy, bool *needs_store);
SV** hv_fetch_mg(NOTXSPROC HV *hv, char *key, U32 klen, I32 lval);
SV** hv_store_mg(NOTXSPROC HV *hv, char *key, U32 klen, SV* val, U32 hash);
HWND handle_From(NOTXSPROC SV *pSv);
char *classname_From(NOTXSPROC SV *pSv);
COLORREF SvCOLORREF(NOTXSPROC SV* c);
HWND CreateTooltip(NOTXSPROC HV* parent);
void CalcControlSize(NOTXSPROC LPPERLWIN32GUI_CREATESTRUCT perlcs, int add_x, int add_y);
BOOL GetObjectName(NOTXSPROC HWND hwnd, char *Name);
BOOL GetObjectNameAndClass(NOTXSPROC HWND hwnd, char *Name, int *obj_class);
HMENU GetMenuFromID(NOTXSPROC int nID);
BOOL GetMenuName(NOTXSPROC HWND hwnd, int nID, char *Name);
BOOL GetAcceleratorName(NOTXSPROC int nID, char *Name);
BOOL GetTimerName(NOTXSPROC HWND hwnd, UINT nID, char *Name);
BOOL GetNotifyIconName(NOTXSPROC HWND hwnd, UINT nID, char *Name);
DWORD CALLBACK RichEditSave(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG FAR *pcb);
DWORD CALLBACK RichEditLoad(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG FAR *pcb);
int CALLBACK BrowseForFolderProc(HWND hWnd, UINT uMsg, LPARAM lParam, LPARAM lpData);
int AdjustSplitterCoord(NOTXSPROC LPPERLWIN32GUI_USERDATA perlud, int x, HWND phwnd);
void DrawSplitter(NOTXSPROC HWND hwnd);
BOOL CALLBACK EnumMyWindowsProc(HWND hwnd, LPARAM lparam);
BOOL CALLBACK CountMyWindowsProc(HWND hwnd, LPARAM lparam);

/* GUI_Events.cpp */
BOOL ProcessEventError(NOTXSPROC char *Name, int* PerlResult);
int DoEvent_Generic(NOTXSPROC char *Name);
int DoEvent_Long(NOTXSPROC char *Name, long argh);
int DoEvent_TwoLongs(NOTXSPROC char *Name, long argone, long argtwo);
int DoEvent_ButtonClick(NOTXSPROC char *Name, WPARAM wParam);
int DoEvent_ListView(NOTXSPROC char *Name, LPARAM lParam);
int DoEvent_TreeView(NOTXSPROC char *Name, LPARAM lParam);
int DoEvent_MouseMove(NOTXSPROC char *Name, WPARAM wParam, LPARAM lParam);
int DoEvent_MouseButton(NOTXSPROC char *Name, WPARAM wParam, LPARAM lParam);
char * DoEvent_NeedText(NOTXSPROC char *Name, UINT id);
int DoEvent_NEM(NOTXSPROC LPPERLWIN32GUI_USERDATA perlud, int iEventId, char *Name, ...);
int DoEvent_NEM_Menu(NOTXSPROC HWND hwnd, int nID, ...);

/* GUI_Options.cpp */
void ParseNEMEvent(NOTXSPROC LPPERLWIN32GUI_CREATESTRUCT perlcs, char *name, SV* event);
void ParseWindowOptions(NOTXSPROC register SV **sp, register SV **mark, I32 ax, I32 items, int from_i, LPPERLWIN32GUI_CREATESTRUCT perlcs);
void ParseMenuItemOptions(NOTXSPROC register SV **sp, register SV **mark, I32 ax, I32 items, int from_i, LPMENUITEMINFO mii, LPPERLWIN32GUI_MENUITEMDATA perlmid, UINT* myItem);
void ParseHeaderItemOptions(NOTXSPROC register SV **sp, register SV **mark, I32 ax, I32 items, int from_i, LPHDITEMA hditem, int * index);
void ParseComboboxExItemOptions(NOTXSPROC register SV **sp, register SV **mark, I32 ax, I32 items, int from_i, COMBOBOXEXITEM *item);


/* GUI_MessageLoops.cpp */
LRESULT CommonMsgLoop(NOTXSPROC HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NEM_WindowMsgLoop(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NEM_ChildMsgLoop(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK ContainerMsgLoop(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK SplitterMsgLoop(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK ButtonMsgLoop(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK ListboxMsgLoop(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK RichEditMsgLoop(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK TabStripMsgLoop(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK GraphicMsgLoop(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK InteractiveGraphicMsgLoop(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK WindowMsgLoop(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK MsgLoop(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK InactiveMsgLoop(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

/*
 * default procedures for controls (not really to be used yet)
 */
static WNDPROC DefButtonProc;
static WNDPROC DefListboxProc;
static WNDPROC DefTabStripProc;
static WNDPROC DefRichEditProc;

/*
 * class-specific routines for (options|create|etc)
*/
BOOL Animation_onParseOption(NOTXSPROC char *option, SV* value, LPPERLWIN32GUI_CREATESTRUCT perlcs);

BOOL Label_onParseOption(NOTXSPROC char *option, SV* value, LPPERLWIN32GUI_CREATESTRUCT perlcs);
void Label_onPostCreate(NOTXSPROC HWND myhandle, LPPERLWIN32GUI_CREATESTRUCT perlcs);

BOOL Listbox_onParseOption(NOTXSPROC char *option, SV* value, LPPERLWIN32GUI_CREATESTRUCT perlcs);
void Listbox_onPostCreate(NOTXSPROC HWND myhandle, LPPERLWIN32GUI_CREATESTRUCT perlcs);

BOOL ListView_onParseOption(NOTXSPROC char *option, SV* value, LPPERLWIN32GUI_CREATESTRUCT perlcs);
void ListView_onPostCreate(NOTXSPROC HWND myhandle, LPPERLWIN32GUI_CREATESTRUCT perlcs);

BOOL Rebar_onParseOption(NOTXSPROC char *option, SV* value, LPPERLWIN32GUI_CREATESTRUCT perlcs);
void Rebar_onPostCreate(NOTXSPROC HWND myhandle, LPPERLWIN32GUI_CREATESTRUCT perlcs);

BOOL Splitter_onParseOption(NOTXSPROC char *option, SV* value, LPPERLWIN32GUI_CREATESTRUCT perlcs);

BOOL TabStrip_onParseOption(NOTXSPROC char *option, SV* value, LPPERLWIN32GUI_CREATESTRUCT perlcs);
void TabStrip_onPostCreate(NOTXSPROC HWND myhandle, LPPERLWIN32GUI_CREATESTRUCT perlcs);

BOOL Textfield_onParseOption(NOTXSPROC char *option, SV* value, LPPERLWIN32GUI_CREATESTRUCT perlcs);

BOOL Toolbar_onParseOption(NOTXSPROC char *option, SV* value, LPPERLWIN32GUI_CREATESTRUCT perlcs);
void Toolbar_onPostCreate(NOTXSPROC HWND myhandle, LPPERLWIN32GUI_CREATESTRUCT perlcs);

BOOL TreeView_onParseOption(NOTXSPROC char *option, SV* value, LPPERLWIN32GUI_CREATESTRUCT perlcs);
void TreeView_onPostCreate(NOTXSPROC HWND myhandle, LPPERLWIN32GUI_CREATESTRUCT perlcs);
