	/*
    ###########################################################################
    # options parsing routines
    ###########################################################################
	*/

#include "GUI.h"

    /*
    ###########################################################################
    # (@)INTERNAL:ParseNEMEvent(*perlcs, char *name, SV event)
    */
void ParseNEMEvent(
    NOTXSPROC
    LPPERLWIN32GUI_CREATESTRUCT perlcs,
	char *name,
	SV* event
) {
    dTHR;
	SV* newval;
	int	eventID;
	int styleModifier;

	eventID = 0;
#ifdef PERLWIN32GUI_STRONGDEBUG
	printf("!XS(ParseNEMEvent) got NEM name '%s'\n", name);
#endif
	if(strcmp(name, "MouseMove") == 0) {
		eventID = PERLWIN32GUI_NEM_MOUSEMOVE;
		styleModifier = PERLWIN32GUI_NEM_CHILD;
	} else if(strcmp(name, "MouseDown") == 0) {
		eventID = PERLWIN32GUI_NEM_MOUSEDOWN;
		styleModifier = PERLWIN32GUI_NEM_CHILD;
	} else if(strcmp(name, "MouseUp") == 0) {
		eventID = PERLWIN32GUI_NEM_MOUSEUP;
		styleModifier = PERLWIN32GUI_NEM_CHILD;
	} else if(strcmp(name, "KeyDown") == 0) {
		eventID = PERLWIN32GUI_NEM_KEYDOWN;
		styleModifier = PERLWIN32GUI_NEM_CHILD;
	} else if(strcmp(name, "KeyUp") == 0) {
		eventID = PERLWIN32GUI_NEM_KEYUP;
		styleModifier = PERLWIN32GUI_NEM_CHILD;
	}
	switch(perlcs->iClass) {

	case PERLWIN32GUI_CLS_WINDOW:
	case PERLWIN32GUI_CLS_DIALOG:
		if(strcmp(name, "Deactivate") == 0) {
			eventID = PERLWIN32GUI_NEM_DEACTIVATE;
		} else if(strcmp(name, "Activate") == 0) {
			eventID = PERLWIN32GUI_NEM_ACTIVATE;
		} else if(strcmp(name, "Terminate") == 0) {
			eventID = PERLWIN32GUI_NEM_TERMINATE;
		} else if(strcmp(name, "Minimize") == 0) {
			eventID = PERLWIN32GUI_NEM_MINIMIZE;
		} else if(strcmp(name, "Maximize") == 0) {
			eventID = PERLWIN32GUI_NEM_MAXIMIZE;
		} else if(strcmp(name, "Resize") == 0) {
			eventID = PERLWIN32GUI_NEM_RESIZE;
		} else {
			if(PL_dowarn) {
				warn("Win32::GUI: Unrecognized event name '%s' in -names!", name);
			}
		}
		break;

	case PERLWIN32GUI_CLS_BUTTON:
	case PERLWIN32GUI_CLS_CHECKBOX:
	case PERLWIN32GUI_CLS_RADIOBUTTON:
		if(strcmp(name, "GotFocus") == 0) {
			eventID = PERLWIN32GUI_NEM_GOTFOCUS;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "LostFocus") == 0) {
			eventID = PERLWIN32GUI_NEM_LOSTFOCUS;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "DblClick") == 0) {
			eventID = PERLWIN32GUI_NEM_DBLCLICK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "Click") == 0) {
			eventID = PERLWIN32GUI_NEM_CLICK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else {
			if(PL_dowarn) {
				warn("Win32::GUI: Unrecognized event name '%s'!", name);
			}
		}
		break;

	case PERLWIN32GUI_CLS_LISTBOX:
		if(strcmp(name, "GotFocus") == 0) {
			eventID = PERLWIN32GUI_NEM_GOTFOCUS;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "LostFocus") == 0) {
			eventID = PERLWIN32GUI_NEM_LOSTFOCUS;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "DblClick") == 0) {
			eventID = PERLWIN32GUI_NEM_DBLCLICK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "Click") == 0) {
			eventID = PERLWIN32GUI_NEM_CLICK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else {
			if(PL_dowarn) {
				warn("Win32::GUI: Unrecognized event name '%s'!", name);
			}
		}
		break;

	case PERLWIN32GUI_CLS_EDIT:
	case PERLWIN32GUI_CLS_RICHEDIT:
		if(strcmp(name, "GotFocus") == 0) {
			eventID = PERLWIN32GUI_NEM_GOTFOCUS;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "LostFocus") == 0) {
			eventID = PERLWIN32GUI_NEM_LOSTFOCUS;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "Change") == 0) {
			eventID = PERLWIN32GUI_NEM_CHANGE;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else {
			if(PL_dowarn) {
				warn("Win32::GUI: Unrecognized event name '%s'!", name);
			}
		}
		break;

	case PERLWIN32GUI_CLS_STATIC:
		if(strcmp(name, "DblClick") == 0) {
			eventID = PERLWIN32GUI_NEM_DBLCLICK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "Click") == 0) {
			eventID = PERLWIN32GUI_NEM_CLICK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else {
			if(PL_dowarn) {
				warn("Win32::GUI: Unrecognized event name '%s'!", name);
			}
		}
		break;

	case PERLWIN32GUI_CLS_COMBOBOX:
		if(strcmp(name, "GotFocus") == 0) {
			eventID = PERLWIN32GUI_NEM_GOTFOCUS;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "LostFocus") == 0) {
			eventID = PERLWIN32GUI_NEM_LOSTFOCUS;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "DblClick") == 0) {
			eventID = PERLWIN32GUI_NEM_DBLCLICK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "Change") == 0) {
			eventID = PERLWIN32GUI_NEM_CHANGE;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else {
			if(PL_dowarn) {
				warn("Win32::GUI: Unrecognized event name '%s'!", name);
			}
		}
		break;

	case PERLWIN32GUI_CLS_TOOLBAR:
		if(strcmp(name, "ButtonClick") == 0) {
			eventID = PERLWIN32GUI_NEM_BUTTONCLICK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else {
			if(PL_dowarn) {
				warn("Win32::GUI: Unrecognized event name '%s'!", name);
			}
		}
		break;

	case PERLWIN32GUI_CLS_LISTVIEW:
		if(strcmp(name, "ItemClick") == 0) {
			eventID = PERLWIN32GUI_NEM_ITEMCLICK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "ItemCheck") == 0) {
			eventID = PERLWIN32GUI_NEM_ITEMCHECK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "ColumnClick") == 0) {
			eventID = PERLWIN32GUI_NEM_COLUMNCLICK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "KeyDown") == 0) {
			eventID = PERLWIN32GUI_NEM_KEYDOWN;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else {
			if(PL_dowarn) {
				warn("Win32::GUI: Unrecognized event name '%s'!", name);
			}
		}
		break;

	case PERLWIN32GUI_CLS_TREEVIEW:
		if(strcmp(name, "NodeClick") == 0) {
			eventID = PERLWIN32GUI_NEM_NODECLICK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "Collapse") == 0) {
			eventID = PERLWIN32GUI_NEM_COLLAPSE;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "Expand") == 0) {
			eventID = PERLWIN32GUI_NEM_EXPAND;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "Collapsing") == 0) {
			eventID = PERLWIN32GUI_NEM_COLLAPSING;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "Expanding") == 0) {
			eventID = PERLWIN32GUI_NEM_EXPANDING;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "KeyDown") == 0) {
			eventID = PERLWIN32GUI_NEM_KEYDOWN;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else {
			if(PL_dowarn) {
				warn("Win32::GUI: Unrecognized event name '%s'!", name);
			}
		}
		break;

	case PERLWIN32GUI_CLS_TAB:
		if(strcmp(name, "Changing") == 0) {
			eventID = PERLWIN32GUI_NEM_CHANGING;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "Change") == 0) {
			eventID = PERLWIN32GUI_NEM_CHANGE;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else {
			if(PL_dowarn) {
				warn("Win32::GUI: Unrecognized event name '%s'!", name);
			}
		}
		break;

	case PERLWIN32GUI_CLS_TOOLTIP:
		if(strcmp(name, "NeedText") == 0) {
			eventID = PERLWIN32GUI_NEM_NEEDTEXT;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else {
			if(PL_dowarn) {
				warn("Win32::GUI: Unrecognized event name '%s'!", name);
			}
		}
		break;

	case PERLWIN32GUI_CLS_REBAR:
		if(strcmp(name, "HeightChange") == 0) {
			eventID = PERLWIN32GUI_NEM_HEIGHTCHANGE;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else {
			if(PL_dowarn) {
				warn("Win32::GUI: Unrecognized event name '%s'!", name);
			}
		}
		break;

	case PERLWIN32GUI_CLS_HEADER:
		if(strcmp(name, "BeginTrack") == 0) {
			eventID = PERLWIN32GUI_NEM_BEGINTRACK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "EndTrack") == 0) {
			eventID = PERLWIN32GUI_NEM_ENDTRACK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "Track") == 0) {
			eventID = PERLWIN32GUI_NEM_TRACK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "DividerDblClick") == 0) {
			eventID = PERLWIN32GUI_NEM_DIVIDERDBLCLICK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "ItemClick") == 0) {
			eventID = PERLWIN32GUI_NEM_ITEMCLICK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else if(strcmp(name, "ItemDblClick") == 0) {
			eventID = PERLWIN32GUI_NEM_ITEMDBLCLICK;
			styleModifier = PERLWIN32GUI_NEM_PARENT;
		} else {
			if(PL_dowarn) {
				warn("Win32::GUI: Unrecognized event name '%s'!", name);
			}
		}
		break;
	}
	if(eventID != 0) {
		if(SvOK(event)) {
			newval = newSVsv(event);
			hv_store(perlcs->hvEvents, name, strlen(name), newval, 0);
			SwitchBit(perlcs->dwEventMask, eventID, 1);
			if(styleModifier != 0) {
				SwitchBit(perlcs->dwPlStyle, styleModifier, 1);
			}
		} else {
			/* got undef */
			SwitchBit(perlcs->dwEventMask, eventID, 0);
		}
	}
#ifdef PERLWIN32GUI_STRONDEBUG
	printf("!XS(ParseNEMEvent) NEM event mask is 0x%x\n", perlcs->dwEventMask);
#endif
}

    /*
    ###########################################################################
    # (@)INTERNAL:ParseWindowOptions(sp, mark, ax ,items, from_i, *perlcs)
    */
void ParseWindowOptions(
    NOTXSPROC
    register SV **sp,
    register SV **mark,
    I32 ax,
    I32 items,
    int from_i,
    LPPERLWIN32GUI_CREATESTRUCT perlcs
) {
    dTHR;
	int i, next_i;
    char * option;
    char * classname;
    SV** stored;
    SV* storing;
#ifdef PERLWIN32GUI_STRONGDEBUG
    // printf("!XS(ParseWindowOptions): from_i=%d, items=%d\n", from_i, items);
#endif
    next_i = -1;
    for(i=from_i; i<items; i++) {
        if(next_i == -1) {
            option = SvPV_nolen(ST(i));
#ifdef PERLWIN32GUI_STRONGDEBUG
            printf("!XS(ParseWindowOptions): got option '%s'\n", option);
#endif
            if(strcmp(option, "-class") == 0) {
                next_i = i + 1;
                perlcs->cs.lpszClass = (LPCTSTR) classname_From(NOTXSCALL ST(next_i));
            } else if(strcmp(option, "-text") == 0
            ||        strcmp(option, "-caption") == 0
            ||        strcmp(option, "-title") == 0) {
                next_i = i + 1;
                perlcs->cs.lpszName = (LPCTSTR) SvPV_nolen(ST(next_i));
            } else if(strcmp(option, "-style") == 0) {
                next_i = i + 1;
                perlcs->cs.style = (DWORD) SvIV(ST(next_i));
				if(PL_dowarn) {
					warn("Win32::GUI: the -style option is deprecated!");
				}
            } else if(strcmp(option, "-pushstyle") == 0
            ||        strcmp(option, "-addstyle") == 0) {
                next_i = i + 1;
                perlcs->cs.style |= (DWORD) SvIV(ST(next_i));
            } else if(strcmp(option, "-popstyle") == 0
            ||        strcmp(option, "-remstyle") == 0
            ||        strcmp(option, "-notstyle") == 0
            ||        strcmp(option, "-negstyle") == 0) {
                next_i = i + 1;
                perlcs->cs.style ^= (DWORD) SvIV(ST(next_i));
            } else if(strcmp(option, "-exstyle") == 0) {
                next_i = i + 1;
                perlcs->cs.dwExStyle = (DWORD) SvIV(ST(next_i));
				if(PL_dowarn) {
					warn("Win32::GUI: the -exstyle option is deprecated!");
				}
            } else if(strcmp(option, "-pushexstyle") == 0
            ||        strcmp(option, "-addexstyle") == 0) {
                next_i = i + 1;
                perlcs->cs.dwExStyle |= (DWORD) SvIV(ST(next_i));
            } else if(strcmp(option, "-popexstyle") == 0
            ||        strcmp(option, "-remexstyle") == 0
            ||        strcmp(option, "-notexstyle") == 0
            ||        strcmp(option, "-negexstyle") == 0) {
                next_i = i + 1;
                perlcs->cs.dwExStyle ^= (DWORD) SvIV(ST(next_i));
            } else if(strcmp(option, "-left") == 0) {
                next_i = i + 1;
                perlcs->cs.x = (int) SvIV(ST(next_i));
            } else if(strcmp(option, "-top") == 0) {
                next_i = i + 1;
                perlcs->cs.y = (int) SvIV(ST(next_i));
            } else if(strcmp(option, "-width") == 0) {
                next_i = i + 1;
                perlcs->cs.cx = (int) SvIV(ST(next_i));
            } else if(strcmp(option, "-height") == 0) {
                next_i = i + 1;
                perlcs->cs.cy = (int) SvIV(ST(next_i));
            } else if(strcmp(option, "-parent") == 0) {
                next_i = i + 1;
                perlcs->cs.hwndParent = (HWND) handle_From(NOTXSCALL ST(next_i));
                if(SvROK(ST(next_i))) {
                	perlcs->hvParent = (HV*) SvRV(ST(next_i));
				}
            } else if(strcmp(option, "-menu") == 0) {
                next_i = i + 1;
                perlcs->cs.hMenu = (HMENU) handle_From(NOTXSCALL ST(next_i));
            } else if(strcmp(option, "-instance") == 0) {
                next_i = i + 1;
                perlcs->cs.hInstance = (HINSTANCE) SvIV(ST(next_i));
            } else if(strcmp(option, "-name") == 0) {
                next_i = i + 1;
                perlcs->szWindowName = SvPV_nolen(ST(next_i));
            } else if(strcmp(option, "-function") == 0) {
                next_i = i + 1;
                perlcs->szWindowFunction = SvPV_nolen(ST(next_i));
            } else if(strcmp(option, "-font") == 0) {
                next_i = i + 1;
                perlcs->hFont = (HFONT) handle_From(NOTXSCALL ST(next_i));
            } else if(strcmp(option, "-foreground") == 0) {
                next_i = i + 1;
                perlcs->clrForeground = SvCOLORREF(NOTXSCALL ST(next_i));
                storing = newSViv((long) perlcs->clrForeground);
				stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-foreground", 11, storing, 0);
            } else if(strcmp(option, "-background") == 0) {
                next_i = i + 1;
                perlcs->clrBackground = SvCOLORREF(NOTXSCALL ST(next_i));
                {
					LOGBRUSH lb;
					ZeroMemory(&lb, sizeof(LOGBRUSH));
			        lb.lbStyle = BS_SOLID;
        			lb.lbColor = perlcs->clrBackground;
					if(perlcs->hBackgroundBrush != NULL) {
						DeleteObject((HGDIOBJ) perlcs->hBackgroundBrush);
					}
        			perlcs->hBackgroundBrush = CreateBrushIndirect(&lb);
				}
                storing = newSViv((long) perlcs->clrBackground);
				stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-background", 11, storing, 0);
                storing = newSViv((long) perlcs->hBackgroundBrush);
				stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-backgroundbrush", 16, storing, 0);
            } else if(strcmp(option, "-size") == 0) {
				next_i = i + 1;
				if(SvROK(ST(next_i)) && SvTYPE(SvRV(ST(next_i))) == SVt_PVAV) {
					SV** t;
					t = av_fetch((AV*)SvRV(ST(next_i)), 0, 0);
					if(t != NULL) {
						perlcs->cs.cx = (int) SvIV(*t);
					}
					t = av_fetch((AV*)SvRV(ST(next_i)), 1, 0);
					if(t != NULL) {
						perlcs->cs.cy = (int) SvIV(*t);
					}
				} else {
					if(PL_dowarn)
						warn("Win32::GUI: Argument to -size is not an array reference!");
				}
            } else if(strcmp(option, "-pos") == 0) {
				next_i = i + 1;
				if(SvROK(ST(next_i)) && SvTYPE(SvRV(ST(next_i))) == SVt_PVAV) {
					SV** t;
					t = av_fetch((AV*)SvRV(ST(next_i)), 0, 0);
					if(t != NULL) {
						perlcs->cs.x = (int) SvIV(*t);
					}
					t = av_fetch((AV*)SvRV(ST(next_i)), 1, 0);
					if(t != NULL) {
						perlcs->cs.y = (int) SvIV(*t);
					}
				} else {
					if(PL_dowarn)
						warn("Win32::GUI: Argument to -pos is not an array reference!");
				}
            } else if(strcmp(option, "-tip") == 0) {
				next_i = i + 1;
				perlcs->szTip = SvPV_nolen(ST(next_i));

            } else if(strcmp(option, "-events") == 0) {
				next_i = i + 1;
				{
					HV* hash;
					SV* val;
					SV* newval;
					char* key;
					I32 keylen;
#ifdef PERLWIN32GUI_STRONGDEBUG
					printf("!XS(ParseWindowOptions): initializing perlcs.hvEvents\n");
#endif
					if((LPVOID) perlcs->hvEvents == NULL) {
						perlcs->hvEvents = newHV();
						perlcs->dwEventMask = 0;
					}
					hash = (HV*) SvRV(ST(next_i));
					hv_iterinit( hash );
					while ( val = hv_iternextsv( hash, &key, &keylen ) ) {
						ParseNEMEvent( NOTXSCALL perlcs, key, val );
					}
				}
				if(perlcs->dwEventMask != 0) {
					SwitchBit(perlcs->dwPlStyle, PERLWIN32GUI_NEM, 1);
					if(perlcs->iEventModel == PERLWIN32GUI_EM_BYNAME) {
						perlcs->iEventModel = PERLWIN32GUI_EM_BYREF;
					}
				} else {
					SwitchBit(perlcs->dwPlStyle, PERLWIN32GUI_NEM, 0);
					if(perlcs->iEventModel == PERLWIN32GUI_EM_BYREF) {
						perlcs->iEventModel = PERLWIN32GUI_EM_BYNAME;
					}
				}
            } else if(strcmp(option, "-cursor") == 0) {
                next_i = i + 1;
                perlcs->hCursor = (HCURSOR) handle_From(NOTXSCALL ST(next_i));

			} else if(strncmp(option, "-on", 3) == 0
			&& (char) option[3] >= 'A' && (char) option[3] <= 'Z') {
				next_i = i + 1;
				{
					char *eventname;
#ifdef PERLWIN32GUI_STRONGDEBUG
					printf("!XS(ParseWindowOptions): initializing perlcs.hvEvents\n");
#endif
					if(perlcs->hvEvents == NULL) {
						perlcs->hvEvents = newHV();
						perlcs->dwEventMask = 0;
					}
					eventname = option+3;
#ifdef PERLWIN32GUI_STRONGDEBUG
					printf("!XS(ParseWindowOptions): calling ParseNEMEvent('%s', '%s')\n", eventname, SvPV_nolen(ST(next_i)));
#endif
					ParseNEMEvent( NOTXSCALL perlcs, eventname, ST(next_i) );
				}
				if(perlcs->dwEventMask != 0) {
					SwitchBit(perlcs->dwPlStyle, PERLWIN32GUI_NEM, 1);
					if(perlcs->iEventModel == PERLWIN32GUI_EM_BYNAME) {
						perlcs->iEventModel = PERLWIN32GUI_EM_BYREF;
					}
				} else {
					SwitchBit(perlcs->dwPlStyle, PERLWIN32GUI_NEM, 0);
					if(perlcs->iEventModel == PERLWIN32GUI_EM_BYREF) {
						perlcs->iEventModel = PERLWIN32GUI_EM_BYNAME;
					}
				}

            } else if(strcmp(option, "-eventmodel") == 0) {
				next_i = i + 1;
				if(stricmp(SvPV_nolen(ST(next_i)), "byname") == 0) {
					perlcs->iEventModel = PERLWIN32GUI_EM_BYNAME;
					SwitchBit(perlcs->dwPlStyle, PERLWIN32GUI_NEM, 0);
				} else if(stricmp(SvPV_nolen(ST(next_i)), "byref") == 0) {
					perlcs->iEventModel = PERLWIN32GUI_EM_BYREF;
					SwitchBit(perlcs->dwPlStyle, PERLWIN32GUI_NEM, 1);
				} else if(stricmp(SvPV_nolen(ST(next_i)), "both") == 0) {
					perlcs->iEventModel = PERLWIN32GUI_EM_BOTH;
					SwitchBit(perlcs->dwPlStyle, PERLWIN32GUI_NEM, 1);
				} else {
					if(PL_dowarn) warn("Win32::GUI: Invalid value for -eventmodel!");
				}

			} else BitmaskOption("-visible", perlcs->cs.style, WS_VISIBLE)
			} else BitmaskOption("-disabled", perlcs->cs.style, WS_DISABLED)
			} else BitmaskOption("-group", perlcs->cs.style, WS_GROUP)
			} else BitmaskOption("-tabstop", perlcs->cs.style, WS_TABSTOP)
			} else BitmaskOption("-hscroll", perlcs->cs.style, WS_HSCROLL)
			} else BitmaskOption("-vscroll", perlcs->cs.style, WS_VSCROLL)
			} else BitmaskOption("-container", perlcs->dwPlStyle, PERLWIN32GUI_CONTAINER)
			}
            // ######################
            // class-specific parsing
            // ######################
            switch(perlcs->iClass) {

            case WIN32__GUI__WINDOW:
            case WIN32__GUI__DIALOG:
                if(strcmp(option, "-minsize") == 0) {
                    next_i = i + 1;
                    if(SvROK(ST(next_i)) && SvTYPE(SvRV(ST(next_i))) == SVt_PVAV) {
                        SV** t;
                        t = av_fetch((AV*)SvRV(ST(next_i)), 0, 0);
                        if(t != NULL) {
							perlcs->iMinWidth = (int) SvIV(*t);
                            storing = newSViv((LONG) SvIV(*t));
                            stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-minwidth", 9, storing, 0);
                        }
                        t = av_fetch((AV*)SvRV(ST(next_i)), 1, 0);
                        if(t != NULL) {
							perlcs->iMinHeight = (int) SvIV(*t);
                            storing = newSViv((LONG) SvIV(*t));
                            stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-minheight", 10, storing, 0);
                        }
                    } else {
                        if(PL_dowarn)
                            warn("Win32::GUI: Argument to -minsize is not an array reference!");
                    }
                } else if(strcmp(option, "-maxsize") == 0) {
                    next_i = i + 1;
                    if(SvROK(ST(next_i)) && SvTYPE(SvRV(ST(next_i))) == SVt_PVAV) {
                        SV** t;
                        t = av_fetch((AV*)SvRV(ST(next_i)), 0, 0);
                        if(t != NULL) {
							perlcs->iMaxWidth = (int) SvIV(*t);
                            storing = newSViv((LONG) SvIV(*t));
                            stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-maxwidth", 9, storing, 0);
                        }
                        t = av_fetch((AV*)SvRV(ST(next_i)), 1, 0);
                        if(t != NULL) {
							perlcs->iMaxHeight = (int) SvIV(*t);
                            storing = newSViv((LONG) SvIV(*t));
                            stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-maxheight", 10, storing, 0);
                        }
                    } else {
                        if(PL_dowarn)
                            warn("Win32::GUI: Argument to -maxsize is not an array reference!");
                    }
                } else if(strcmp(option, "-minwidth") == 0) {
                    next_i = i + 1;
                    perlcs->iMinWidth = (int) SvIV(ST(next_i));
                    storing = newSViv((LONG) SvIV(ST(next_i)));
                    stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-minwidth", 9, storing, 0);
                } else if(strcmp(option, "-minheight") == 0) {
                    next_i = i + 1;
                    perlcs->iMinHeight = (int) SvIV(ST(next_i));
                    storing = newSViv((LONG) SvIV(ST(next_i)));
                    stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-minheight", 10, storing, 0);
                } else if(strcmp(option, "-maxwidth") == 0) {
                    next_i = i + 1;
                    perlcs->iMaxWidth = (int) SvIV(ST(next_i));
                    storing = newSViv((LONG) SvIV(ST(next_i)));
                    stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-maxwidth", 9, storing, 0);
                } else if(strcmp(option, "-maxheight") == 0) {
                    next_i = i + 1;
                    perlcs->iMaxHeight = (int) SvIV(ST(next_i));
                    storing = newSViv((LONG) SvIV(ST(next_i)));
                    stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-maxheight", 10, storing, 0);
			    } else BitmaskOption("-topmost", perlcs->cs.dwExStyle, WS_EX_TOPMOST)
			    } else BitmaskOption("-controlparent", perlcs->cs.dwExStyle, WS_EX_CONTROLPARENT)
				} else if(strcmp(option, "-hasmaximize") == 0
				||        strcmp(option, "-maximizebox") == 0) {
                    next_i = i + 1;
                    SwitchBit(perlcs->cs.style, WS_MAXIMIZEBOX, SvIV(ST(next_i)));
				} else if(strcmp(option, "-hasminimize") == 0
				||        strcmp(option, "-minimizebox") == 0) {
                    next_i = i + 1;
                    SwitchBit(perlcs->cs.style, WS_MINIMIZEBOX, SvIV(ST(next_i)));
				} else if(strcmp(option, "-sizable") == 0
				||        strcmp(option, "-resizable") == 0) {
                    next_i = i + 1;
                    SwitchBit(perlcs->cs.style, WS_THICKFRAME, SvIV(ST(next_i)));
				} else if(strcmp(option, "-sysmenu") == 0
				||        strcmp(option, "-menubox") == 0
				||        strcmp(option, "-controlbox") == 0) {
					next_i = i + 1;
					SwitchBit(perlcs->cs.style, WS_SYSMENU, SvIV(ST(next_i)));
				} else if(strcmp(option, "-helpbutton") == 0
				||        strcmp(option, "-helpbox") == 0
				||        strcmp(option, "-hashelp") == 0) {
                    next_i = i + 1;
                    SwitchBit(perlcs->cs.dwExStyle, WS_EX_CONTEXTHELP, SvIV(ST(next_i)));
				} else if(strcmp(option, "-accel") == 0
				||        strcmp(option, "-accelerators") == 0
				||        strcmp(option, "-acceleratortable") == 0) {
					next_i = i + 1;
					perlcs->hAcc = (HACCEL) handle_From(NOTXSCALL ST(next_i));
                    storing = newSViv((LONG) handle_From(NOTXSCALL ST(next_i)));
                    stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-accel", 6, storing, 0);
				} else BitmaskOption("-titlebar", perlcs->cs.style, WS_CAPTION)
				} else BitmaskOption("-toolwindow", perlcs->cs.dwExStyle, WS_EX_TOOLWINDOW)
				} else BitmaskOption("-appwindow", perlcs->cs.dwExStyle, WS_EX_APPWINDOW)
				}
				break;

            case WIN32__GUI__STATIC:
				if(Label_onParseOption(NOTXSCALL option, ST(i+1), perlcs)) {
					next_i = i + 1;
				}
                break;

            case WIN32__GUI__EDIT:
            case WIN32__GUI__RICHEDIT:
            	if(Textfield_onParseOption(NOTXSCALL option, ST(i+1), perlcs)) {
					next_i = i + 1;
				}
                break;

            case WIN32__GUI__BUTTON:
            case WIN32__GUI__RADIOBUTTON:
            case WIN32__GUI__CHECKBOX:
                if(strcmp(option, "-align") == 0) {
                    next_i = i + 1;
                    if(strcmp(SvPV_nolen(ST(next_i)), "left") == 0) {
                        SwitchBit(perlcs->cs.style, BS_LEFT, 1);
                        SwitchBit(perlcs->cs.style, BS_CENTER, 0);
                        SwitchBit(perlcs->cs.style, BS_RIGHT, 0);
                    } else if(strcmp(SvPV_nolen(ST(next_i)), "center") == 0) {
                        SwitchBit(perlcs->cs.style, BS_LEFT, 0);
                        SwitchBit(perlcs->cs.style, BS_CENTER, 1);
                        SwitchBit(perlcs->cs.style, BS_RIGHT, 0);
                    } else if(strcmp(SvPV_nolen(ST(next_i)), "right") == 0) {
                        SwitchBit(perlcs->cs.style, BS_LEFT, 0);
                        SwitchBit(perlcs->cs.style, BS_CENTER, 0);
                        SwitchBit(perlcs->cs.style, BS_RIGHT, 1);
                    } else {
                        if(PL_dowarn) warn("Win32::GUI: Invalid value for -align!");
                    }
                } else if(strcmp(option, "-valign") == 0) {
                    next_i = i + 1;
                    if(strcmp(SvPV_nolen(ST(next_i)), "top") == 0) {
                        SwitchBit(perlcs->cs.style, BS_TOP, 1);
                        SwitchBit(perlcs->cs.style, BS_BOTTOM, 0);
                    } else if(strcmp(SvPV_nolen(ST(next_i)), "center") == 0) {
                        SwitchBit(perlcs->cs.style, BS_TOP, 1);
                        SwitchBit(perlcs->cs.style, BS_BOTTOM, 1);
                    } else if(strcmp(SvPV_nolen(ST(next_i)), "bottom") == 0) {
                        SwitchBit(perlcs->cs.style, BS_TOP, 0);
                        SwitchBit(perlcs->cs.style, BS_BOTTOM, 1);
                    } else {
                        if(PL_dowarn) warn("Win32::GUI: Invalid value for -valign!");
                    }
                } else if(strcmp(option, "-ok") == 0) {
                    next_i = i + 1;
                    if(SvIV(ST(next_i)) != 0) {
                        perlcs->cs.hMenu = (HMENU) IDOK;
                    }
                } else if(strcmp(option, "-cancel") == 0) {
                    next_i = i + 1;
                    if(SvIV(ST(next_i)) != 0) {
                        perlcs->cs.hMenu = (HMENU) IDCANCEL;
                    }
				} else BitmaskOption("-default", perlcs->cs.style, BS_DEFPUSHBUTTON)
                } else if(strcmp(option, "-bitmap") == 0
                ||        strcmp(option, "-picture") == 0) {
                    next_i = i + 1;
                    SwitchBit(perlcs->cs.style, BS_BITMAP, 1);
                    perlcs->hImageList = (HIMAGELIST) handle_From(NOTXSCALL ST(next_i));
                } else if(strcmp(option, "-icon") == 0) {
                    next_i = i + 1;
                    SwitchBit(perlcs->cs.style, BS_BITMAP, 1);
                    perlcs->hImageList = (HIMAGELIST) handle_From(NOTXSCALL ST(next_i));
                } else if(strcmp(option, "-checked") == 0) {
                    next_i = i + 1;
                    SwitchBit(perlcs->dwPlStyle, PERLWIN32GUI_CHECKED, SvIV(ST(next_i)));
                    SwitchBit(perlcs->dwPlStyle, PERLWIN32GUI_SEENCHECKED, 1);
                }
                break;

            case WIN32__GUI__LISTBOX:
				if(Listbox_onParseOption(NOTXSCALL option, ST(i+1), perlcs)) {
					next_i = i + 1;
				}
                break;

            case WIN32__GUI__TAB:
				if(TabStrip_onParseOption(NOTXSCALL option, ST(i+1), perlcs)) {
					next_i = i + 1;
				}
                break;

            case WIN32__GUI__TOOLBAR:
				if(Toolbar_onParseOption(NOTXSCALL option, ST(i+1), perlcs)) {
					next_i = i + 1;
				}
                break;

            case WIN32__GUI__LISTVIEW:
				if(ListView_onParseOption(NOTXSCALL option, ST(i+1), perlcs)) {
					next_i = i + 1;
				}
                break;

            case WIN32__GUI__TREEVIEW:
				if(TreeView_onParseOption(NOTXSCALL option, ST(i+1), perlcs)) {
					next_i = i + 1;
				}
                break;

            case WIN32__GUI__TRACKBAR:
				BitmaskOption("-vertical", perlcs->cs.style, TBS_VERT)
				} else BitmaskOption("-noticks", perlcs->cs.style, TBS_NOTICKS)
				} else BitmaskOption("-nothumb", perlcs->cs.style, TBS_NOTHUMB)
                }
                break;

            case WIN32__GUI__UPDOWN:
                if(strcmp(option, "-align") == 0) {
                    next_i = i + 1;
                    if(strcmp(SvPV_nolen(ST(next_i)), "left") == 0) {
                        SwitchBit(perlcs->cs.style, UDS_ALIGNLEFT, 1);
                        SwitchBit(perlcs->cs.style, UDS_ALIGNRIGHT, 0);
                    } else if(strcmp(SvPV_nolen(ST(next_i)), "right") == 0) {
                        SwitchBit(perlcs->cs.style, UDS_ALIGNLEFT, 0);
                        SwitchBit(perlcs->cs.style, UDS_ALIGNRIGHT, 1);
                    } else {
                        if(PL_dowarn) warn("Win32::GUI: Invalid value for -align!");
                    }
				} else BitmaskOption("-nothousands", perlcs->cs.style, UDS_NOTHOUSANDS)
				} else BitmaskOption("-wrap", perlcs->cs.style, UDS_WRAP)
				} else BitmaskOption("-horizontal", perlcs->cs.style, UDS_HORZ)
				} else BitmaskOption("-autobuddy", perlcs->cs.style, UDS_AUTOBUDDY)
				} else BitmaskOption("-setbuddy", perlcs->cs.style, UDS_SETBUDDYINT)
                }
                break;

            case WIN32__GUI__ANIMATION:
				if(Animation_onParseOption(NOTXSCALL option, ST(i+1), perlcs)) {
					next_i = i + 1;
				}
                break;

            case WIN32__GUI__REBAR:
				if(Rebar_onParseOption(NOTXSCALL option, ST(i+1), perlcs)) {
					next_i = i + 1;
				}
                break;

            case WIN32__GUI__PROGRESS:
                BitmaskOption("-smooth", perlcs->cs.style, PBS_SMOOTH)
                } else BitmaskOption("-vertical", perlcs->cs.style, PBS_VERTICAL)
                }
                break;

            case WIN32__GUI__HEADER:
                if(strcmp(option, "-imagelist") == 0) {
                    next_i = i + 1;
                    perlcs->hImageList = (HIMAGELIST) handle_From(NOTXSCALL ST(next_i));
                } else BitmaskOption("-buttons", perlcs->cs.style, HDS_BUTTONS)
                } else BitmaskOption("-hottrack", perlcs->cs.style, HDS_HOTTRACK)
                }
                break;

			case WIN32__GUI__COMBOBOXEX:
                if(strcmp(option, "-imagelist") == 0) {
                    next_i = i + 1;
				    perlcs->hImageList = (HIMAGELIST) handle_From(NOTXSCALL ST(next_i));
				}
				break;

            case WIN32__GUI__GRAPHIC:
                if(strcmp(option, "-interactive") == 0) {
                    next_i = i + 1;
                    if(SvIV(ST(next_i))) {
			        	perlcs->cs.lpszClass = "Win32::GUI::InteractiveGraphic";
					} else {
						perlcs->cs.lpszClass = "Win32::GUI::Graphic";
					}
				}
				break;

            case WIN32__GUI__SPLITTER:
				if(Splitter_onParseOption(NOTXSCALL option, ST(i+1), perlcs)) {
					next_i = i + 1;
				}
				break;
            }
        } else {
            next_i = -1;
        }
    }
}

    /*
    ###########################################################################
    # (@)INTERNAL:ParseMenuItemOptions(sp, mark, ax, items, from_i, mii, *item)
    */
void ParseMenuItemOptions(
    NOTXSPROC
    register SV **sp,
    register SV **mark,
    I32 ax,
    I32 items,
    int from_i,
    LPMENUITEMINFO mii,
    LPPERLWIN32GUI_MENUITEMDATA perlmid,
    UINT* myItem
) {
    dTHR;
	int i, next_i;
    char * option;
    unsigned int textlength;
    next_i = -1;
#ifdef PERLWIN32GUI_STRONGDEBUG
	printf("!XS(ParseMenuItemOptions) called with items=%d, from_i=%d\n", items, from_i);
#endif
	for(i = from_i; i < items; i++) {
        if(next_i == -1) {
            option = SvPV_nolen(ST(i));
#ifdef PERLWIN32GUI_STRONGDEBUG
			printf("!XS(ParseMenuItemOptions) got option '%s'\n", option);
#endif
            if(strcmp(option, "-mask") == 0) {
                next_i = i + 1;
                mii->fMask = (UINT) SvIV(ST(next_i));
            } else if(strcmp(option, "-flag") == 0) {
                next_i = i + 1;
                mii->fType = (UINT) SvIV(ST(next_i));
            } else if(strcmp(option, "-state") == 0) {
                SwitchBit(mii->fMask, MIIM_STATE, 1);
                next_i = i + 1;
                mii->fState = (UINT) SvIV(ST(next_i));
            } else if(strcmp(option, "-id") == 0) {
                SwitchBit(mii->fMask, MIIM_ID, 1);
                next_i = i + 1;
                mii->wID = (UINT) SvIV(ST(next_i));
            } else if(strcmp(option, "-submenu") == 0) {
                SwitchBit(mii->fMask, MIIM_SUBMENU, 1);
                next_i = i + 1;
                mii->hSubMenu = (HMENU) handle_From(NOTXSCALL ST(next_i));
            } else if(strcmp(option, "-text") == 0) {
                SwitchBit(mii->fMask, MIIM_TYPE, 1);
                SwitchBit(mii->fType, MFT_STRING, 1);
                next_i = i + 1;
                mii->dwTypeData = SvPV(ST(next_i), textlength);
                mii->cch = textlength;
            } else if(strcmp(option, "-item") == 0) {
                next_i = i + 1;
                *myItem = SvIV(ST(next_i));
            } else if(strcmp(option, "-separator") == 0) {
                SwitchBit(mii->fMask, MIIM_TYPE, 1);
                next_i = i + 1;
                SwitchBit(mii->fType, MFT_SEPARATOR, SvIV(ST(next_i)));
            } else if(strcmp(option, "-default") == 0) {
                SwitchBit(mii->fMask, MIIM_STATE, 1);
                next_i = i + 1;
                SwitchBit(mii->fState, MFS_DEFAULT, SvIV(ST(next_i)));
            } else if(strcmp(option, "-checked") == 0) {
                SwitchBit(mii->fMask, MIIM_STATE, 1);
                next_i = i + 1;
                SwitchBit(mii->fState, MFS_CHECKED, SvIV(ST(next_i)));
            } else if(strcmp(option, "-enabled") == 0) {
                SwitchBit(mii->fMask, MIIM_STATE, 1);
                next_i = i + 1;
                SwitchBit(mii->fState, MFS_ENABLED, SvIV(ST(next_i)));
            } else if(strcmp(option, "-name") == 0) {
                next_i = i + 1;
#ifdef PERLWIN32GUI_STRONGDEBUG
				printf("!XS(ParseMenuItemOptions) got -name => '%s'\n", SvPV_nolen(ST(next_i)));
#endif
				strcpy( (perlmid->szName), SvPV_nolen(ST(next_i)) );
                SwitchBit(mii->fMask, MIIM_DATA, 1);
				mii->dwItemData = (DWORD) perlmid;
#ifdef PERLWIN32GUI_STRONGDEBUG
				printf("!XS(ParseMenuItemOptions) done -name ('%s')\n", perlmid->szName);
#endif
            } else if(strcmp(option, "-onClick") == 0) {
                next_i = i + 1;
#ifdef PERLWIN32GUI_STRONGDEBUG
				printf("!XS(ParseMenuItemOptions) got -onClick => '%s'\n", SvPV_nolen(ST(next_i)));
#endif
                SwitchBit(mii->fMask, MIIM_DATA, 1);
				/* perlmid->svCode = newSVsv(ST(next_i)); */
				sv_setsv(perlmid->svCode, ST(next_i));
				mii->dwItemData = (DWORD) perlmid;
#ifdef PERLWIN32GUI_STRONGDEBUG
				printf("!XS(ParseMenuItemOptions) done -onClick newSVsv\n");
#endif
            }
        } else {
            next_i = -1;
        }
    }
}

    /*
    ###########################################################################
    # (@)INTERNAL:ParseHeaderItemOptions(sp, mark, ax ,items, from_i, *hditem, *index)
    */
void ParseHeaderItemOptions(
    NOTXSPROC
    register SV **sp,
    register SV **mark,
    I32 ax,
    I32 items,
    int from_i,
    LPHDITEMA hditem,
    int * index
) {
    dTHR;
	int i, next_i;
    char * option;
    unsigned int tlen;

    next_i = -1;
    for(i = from_i; i < items; i++) {
        if(next_i == -1) {
            option = SvPV_nolen(ST(i));
            if(strcmp(option, "-text") == 0) {
                next_i = i + 1;
                hditem->pszText = SvPV(ST(next_i), tlen);
                hditem->cchTextMax = tlen;
                SwitchBit(hditem->mask, HDI_TEXT, 1);
                SwitchBit(hditem->fmt, HDF_STRING, 1);
            } else if(strcmp(option, "-image") == 0) {
                next_i = i + 1;
                hditem->iImage = SvIV(ST(next_i));
                SwitchBit(hditem->mask, HDI_IMAGE, 1);
                SwitchBit(hditem->fmt, HDF_IMAGE, 1);
            } else if(strcmp(option, "-bitmap") == 0) {
                next_i = i + 1;
                hditem->hbm = (HBITMAP) handle_From(NOTXSCALL ST(next_i));
                SwitchBit(hditem->mask, HDI_BITMAP, 1);
                SwitchBit(hditem->fmt, HDF_BITMAP, 1);
            } else if(strcmp(option, "-bitmaponright") == 0) {
                next_i = i + 1;
                SwitchBit(hditem->fmt, HDF_BITMAP_ON_RIGHT, SvIV(ST(next_i)));
            } else if(strcmp(option, "-width") == 0) {
                next_i = i + 1;
                hditem->cxy = SvIV(ST(next_i));
                SwitchBit(hditem->mask, HDI_WIDTH, 1);
                SwitchBit(hditem->mask, HDI_HEIGHT, 0);
            } else if(strcmp(option, "-height") == 0) {
                next_i = i + 1;
                hditem->cxy = SvIV(ST(next_i));
                SwitchBit(hditem->mask, HDI_WIDTH, 0);
                SwitchBit(hditem->mask, HDI_HEIGHT, 1);
            } else if(strcmp(option, "-order") == 0) {
                next_i = i + 1;
                hditem->iOrder = SvIV(ST(next_i));
                SwitchBit(hditem->mask, HDI_ORDER, 1);
            } else if(strcmp(option, "-align") == 0) {
                next_i = i + 1;
                if(strcmp(SvPV_nolen(ST(next_i)), "left") == 0) {
                    SwitchBit(hditem->fmt, HDF_LEFT, 1);
                    SwitchBit(hditem->fmt, HDF_CENTER, 0);
                    SwitchBit(hditem->fmt, HDF_RIGHT, 0);
                } else if(strcmp(SvPV_nolen(ST(next_i)), "center") == 0) {
                    SwitchBit(hditem->fmt, HDF_LEFT, 0);
                    SwitchBit(hditem->fmt, HDF_CENTER, 1);
                    SwitchBit(hditem->fmt, HDF_RIGHT, 0);
                } else if(strcmp(SvPV_nolen(ST(next_i)), "right") == 0) {
                    SwitchBit(hditem->fmt, HDF_LEFT, 0);
                    SwitchBit(hditem->fmt, HDF_CENTER, 0);
                    SwitchBit(hditem->fmt, HDF_RIGHT, 1);
                } else {
                    if(PL_dowarn) warn("Win32::GUI: Invalid value for -align!");
                }
            } else
            if(strcmp(option, "-item") == 0
            || strcmp(option, "-index") == 0) {
                next_i = i + 1;
                *index = SvIV(ST(next_i));
            }

        } else {
            next_i = -1;
        }
    }
}

    /*
    ###########################################################################
    # (@)INTERNAL:ParseComboboxExItemOptions(sp, mark, ax ,items, from_i, *item)
    */
void ParseComboboxExItemOptions(
    NOTXSPROC
    register SV **sp,
    register SV **mark,
    I32 ax,
    I32 items,
    int from_i,
    COMBOBOXEXITEM *item
) {
    dTHR;
    int i, next_i;
    char * option;
    unsigned int tlen;

    next_i = -1;
    for(i = from_i; i < items; i++) {
        if(next_i == -1) {
            option = SvPV_nolen(ST(i));
            if(strcmp(option, "-text") == 0) {
                next_i = i + 1;
                item->pszText = SvPV(ST(next_i), tlen);
                item->cchTextMax = tlen;
                SwitchBit(item->mask, CBEIF_TEXT, 1);
            } else if(strcmp(option, "-image") == 0) {
                next_i = i + 1;
                item->iImage = SvIV(ST(next_i));
                SwitchBit(item->mask, CBEIF_IMAGE, 1);
            } else if(strcmp(option, "-selectedimage") == 0) {
                next_i = i + 1;
                item->iSelectedImage = SvIV(ST(next_i));
                SwitchBit(item->mask, CBEIF_SELECTEDIMAGE, 1);
            } else
            if(strcmp(option, "-item") == 0
            || strcmp(option, "-index") == 0) {
                next_i = i + 1;
                item->iItem = SvIV(ST(next_i));
            }
        } else {
            next_i = -1;
        }
    }
}
