
	/*
	###########################################################################
    # (@)PACKAGE:Win32::GUI::Label
    ###########################################################################
	*/

#include "GUI.h"

BOOL
Label_onParseOption(NOTXSPROC char *option, SV* value, LPPERLWIN32GUI_CREATESTRUCT perlcs) {
	BOOL retval;
	retval = FALSE;
	if(strcmp(option, "-align") == 0) {
		retval = TRUE;
		if(strcmp(SvPV_nolen(value), "left") == 0) {
			SwitchBit(perlcs->cs.style, SS_LEFT, 1);
			SwitchBit(perlcs->cs.style, SS_CENTER, 0);
			SwitchBit(perlcs->cs.style, SS_RIGHT, 0);
		} else if(strcmp(SvPV_nolen(value), "center") == 0) {
			SwitchBit(perlcs->cs.style, SS_LEFT, 0);
			SwitchBit(perlcs->cs.style, SS_CENTER, 1);
			SwitchBit(perlcs->cs.style, SS_RIGHT, 0);
		} else if(strcmp(SvPV_nolen(value), "right") == 0) {
			SwitchBit(perlcs->cs.style, SS_LEFT, 0);
			SwitchBit(perlcs->cs.style, SS_CENTER, 0);
			SwitchBit(perlcs->cs.style, SS_RIGHT, 1);
		} else {
			if(PL_dowarn) warn("Win32::GUI: Invalid value for -align!");
		}
	} else if(strcmp(option, "-bitmap") == 0
	||        strcmp(option, "-picture") == 0) {
		retval = TRUE;
		SwitchBit(perlcs->cs.style, SS_BITMAP, 1);
		perlcs->hImageList = (HIMAGELIST) handle_From(NOTXSCALL value);
	} else if(strcmp(option, "-truncate") == 0) {
		retval = TRUE;
		if(strcmp(SvPV_nolen(value), "path") == 0) {
			SwitchBit(perlcs->cs.style, SS_PATHELLIPSIS, 1);
			SwitchBit(perlcs->cs.style, SS_ENDELLIPSIS, 0);
			SwitchBit(perlcs->cs.style, SS_WORDELLIPSIS, 0);
		} else if(strcmp(SvPV_nolen(value), "word") == 0) {
			SwitchBit(perlcs->cs.style, SS_PATHELLIPSIS, 0);
			SwitchBit(perlcs->cs.style, SS_ENDELLIPSIS, 0);
			SwitchBit(perlcs->cs.style, SS_WORDELLIPSIS, 1);
		} else if(SvIV(value)) {
			SwitchBit(perlcs->cs.style, SS_PATHELLIPSIS, 0);
			SwitchBit(perlcs->cs.style, SS_ENDELLIPSIS, 1);
			SwitchBit(perlcs->cs.style, SS_WORDELLIPSIS, 0);
		} else {
			SwitchBit(perlcs->cs.style, SS_PATHELLIPSIS, 0);
			SwitchBit(perlcs->cs.style, SS_ENDELLIPSIS, 0);
			SwitchBit(perlcs->cs.style, SS_WORDELLIPSIS, 0);
		}
	} else if(strcmp(option, "-frame") == 0) {
		retval = TRUE;
		if(strcmp(SvPV_nolen(value), "black") == 0) {
			SwitchBit(perlcs->cs.style, SS_BLACKFRAME, 1);
			SwitchBit(perlcs->cs.style, SS_GRAYFRAME, 0);
			SwitchBit(perlcs->cs.style, SS_WHITEFRAME, 0);
			SwitchBit(perlcs->cs.style, SS_ETCHEDFRAME, 0);
		} else if(strcmp(SvPV_nolen(value), "gray") == 0) {
			SwitchBit(perlcs->cs.style, SS_BLACKFRAME, 0);
			SwitchBit(perlcs->cs.style, SS_GRAYFRAME, 1);
			SwitchBit(perlcs->cs.style, SS_WHITEFRAME, 0);
			SwitchBit(perlcs->cs.style, SS_ETCHEDFRAME, 0);
		} else if(strcmp(SvPV_nolen(value), "white") == 0) {
			SwitchBit(perlcs->cs.style, SS_BLACKFRAME, 0);
			SwitchBit(perlcs->cs.style, SS_GRAYFRAME, 0);
			SwitchBit(perlcs->cs.style, SS_WHITEFRAME, 1);
			SwitchBit(perlcs->cs.style, SS_ETCHEDFRAME, 0);
		} else if(strcmp(SvPV_nolen(value), "etched") == 0) {
			SwitchBit(perlcs->cs.style, SS_BLACKFRAME, 0);
			SwitchBit(perlcs->cs.style, SS_GRAYFRAME, 0);
			SwitchBit(perlcs->cs.style, SS_WHITEFRAME, 0);
			SwitchBit(perlcs->cs.style, SS_ETCHEDFRAME, 1);
		} else {
			SwitchBit(perlcs->cs.style, SS_BLACKFRAME, 0);
			SwitchBit(perlcs->cs.style, SS_GRAYFRAME, 0);
			SwitchBit(perlcs->cs.style, SS_WHITEFRAME, 0);
			SwitchBit(perlcs->cs.style, SS_ETCHEDFRAME, 0);
		}
	} else if(strcmp(option, "-fill") == 0) {
		retval = TRUE;
		if(strcmp(SvPV_nolen(value), "black") == 0) {
			SwitchBit(perlcs->cs.style, SS_BLACKRECT, 1);
			SwitchBit(perlcs->cs.style, SS_GRAYRECT, 0);
			SwitchBit(perlcs->cs.style, SS_WHITERECT, 0);
		} else if(strcmp(SvPV_nolen(value), "gray") == 0) {
			SwitchBit(perlcs->cs.style, SS_BLACKRECT, 0);
			SwitchBit(perlcs->cs.style, SS_GRAYRECT, 1);
			SwitchBit(perlcs->cs.style, SS_WHITERECT, 0);
		} else if(strcmp(SvPV_nolen(value), "white") == 0) {
			SwitchBit(perlcs->cs.style, SS_BLACKRECT, 0);
			SwitchBit(perlcs->cs.style, SS_GRAYRECT, 0);
			SwitchBit(perlcs->cs.style, SS_WHITERECT, 1);
		} else if(strcmp(SvPV_nolen(value), "etched") == 0) {
			SwitchBit(perlcs->cs.style, SS_BLACKRECT, 0);
			SwitchBit(perlcs->cs.style, SS_GRAYRECT, 0);
			SwitchBit(perlcs->cs.style, SS_WHITERECT, 0);
		} else {
			SwitchBit(perlcs->cs.style, SS_BLACKRECT, 0);
			SwitchBit(perlcs->cs.style, SS_GRAYRECT, 0);
			SwitchBit(perlcs->cs.style, SS_WHITERECT, 0);
		}
	} else BitmaskOptionValue("-sunken", perlcs->cs.style, SS_SUNKEN)
	} else if(strcmp(option, "-wrap") == 0) {
		retval = TRUE;
		if(SvIV(value)) {
			SwitchBit(perlcs->cs.style, SS_LEFTNOWORDWRAP, 0);
		} else {
			SwitchBit(perlcs->cs.style, SS_LEFTNOWORDWRAP, 1);
		}
	} else if(strcmp(option, "-notify") == 0) {
		retval = TRUE;
		SwitchBit(perlcs->cs.style, SS_NOTIFY, SvIV(value));
	}
	return retval;
}

void
Label_onPostCreate(NOTXSPROC HWND myhandle, LPPERLWIN32GUI_CREATESTRUCT perlcs) {
	if(perlcs->hImageList != NULL) {
		if(perlcs->cs.style & SS_ICON) {
			SendMessage(
				myhandle,
				STM_SETIMAGE,
				(WPARAM) IMAGE_ICON,
				(LPARAM) perlcs->hImageList
			);
		} else {
			SendMessage(
				myhandle,
				STM_SETIMAGE,
				(WPARAM) IMAGE_BITMAP,
				(LPARAM) perlcs->hImageList
			);
		}
	}
}


MODULE = Win32::GUI::Label		PACKAGE = Win32::GUI::Label

PROTOTYPES: DISABLE


