	/*
    ###########################################################################
    # (@)PACKAGE:Win32::GUI::ListView
    ###########################################################################
	*/

#include "GUI.h"

BOOL
ListView_onParseOption(NOTXSPROC char *option, SV* value, LPPERLWIN32GUI_CREATESTRUCT perlcs) {
	BOOL retval;
	retval = FALSE;
	if(strcmp(option, "-align") == 0) {
		retval = TRUE;
		if(strcmp(SvPV_nolen(value), "left") == 0) {
			SwitchBit(perlcs->cs.style, LVS_ALIGNLEFT, 1);
			SwitchBit(perlcs->cs.style, LVS_ALIGNTOP, 0);
		} else if(strcmp(SvPV_nolen(value), "top") == 0) {
			SwitchBit(perlcs->cs.style, LVS_ALIGNLEFT, 0);
			SwitchBit(perlcs->cs.style, LVS_ALIGNTOP, 1);
		} else {
			if(PL_dowarn) warn("Win32::GUI: Invalid value for -align!");
		}
	} else if(strcmp(option, "-imagelist") == 0) {
		retval = TRUE;
		perlcs->hImageList = (HIMAGELIST) handle_From(NOTXSCALL value);
	} else BitmaskOptionValue("-nocolumnheader", perlcs->cs.style, LVS_NOCOLUMNHEADER)
	} else BitmaskOptionValue("-nosortheader",   perlcs->cs.style, LVS_NOSORTHEADER)
	} else BitmaskOptionValue("-singlesel",      perlcs->cs.style, LVS_SINGLESEL)
	} else BitmaskOptionValue("-autoarrange",    perlcs->cs.style, LVS_AUTOARRANGE)
	} else BitmaskOptionValue("-showselalways",  perlcs->cs.style, LVS_SHOWSELALWAYS)
	} else BitmaskOptionValue("-sortascending",  perlcs->cs.style, LVS_SORTASCENDING)
	} else BitmaskOptionValue("-sortdescending", perlcs->cs.style, LVS_SORTDESCENDING)
	} else BitmaskOptionValue("-fullrowselect",  perlcs->cs.dwExStyle, LVS_EX_FULLROWSELECT)
	} else BitmaskOptionValue("-gridlines",      perlcs->cs.dwExStyle, LVS_EX_GRIDLINES)
	} else BitmaskOptionValue("-reordercolumns", perlcs->cs.dwExStyle, LVS_EX_HEADERDRAGDROP)
	} else BitmaskOptionValue("-checkboxes",     perlcs->cs.dwExStyle, LVS_EX_CHECKBOXES)
	} else BitmaskOptionValue("-hottrack",       perlcs->cs.dwExStyle, LVS_EX_TRACKSELECT)
	}
	return retval;
}

void
ListView_onPostCreate(NOTXSPROC HWND myhandle, LPPERLWIN32GUI_CREATESTRUCT perlcs) {
	if(perlcs->hImageList != NULL) {
		ListView_SetImageList(myhandle, perlcs->hImageList, LVSIL_NORMAL);
		ListView_SetImageList(myhandle, perlcs->hImageList, LVSIL_SMALL);
	}
	ListView_SetExtendedListViewStyle(myhandle, perlcs->cs.dwExStyle);
}

MODULE = Win32::GUI::ListView		PACKAGE = Win32::GUI::ListView

    ###########################################################################
    # (@)METHOD:InsertColumn(%OPTIONS)
int
InsertColumn(handle,...)
    HWND handle
PREINIT:
    LV_COLUMN Column;
    unsigned int tlen;
    int i, next_i;
    int iCol;
    char * option;
CODE:
    ZeroMemory(&Column, sizeof(LV_COLUMN));
    next_i = -1;
    for(i = 1; i < items; i++) {
        if(next_i == -1) {
            option = SvPV_nolen(ST(i));
            if(strcmp(option, "-text") == 0) {
                next_i = i + 1;
                Column.pszText = SvPV(ST(next_i), tlen);
                Column.cchTextMax = tlen;
                Column.mask |= LVCF_TEXT;
            } else if(strcmp(option, "-align") == 0) {
                next_i = i + 1;
                if(strcmp(SvPV_nolen(ST(next_i)), "right") == 0) {
                    Column.fmt = LVCFMT_RIGHT;
                    Column.mask |= LVCF_FMT;
                } else if(strcmp(SvPV_nolen(ST(next_i)), "left") == 0) {
                    Column.fmt = LVCFMT_LEFT;
                    Column.mask |= LVCF_FMT;
                } else if(strcmp(SvPV_nolen(ST(next_i)), "center") == 0) {
                    Column.fmt = LVCFMT_CENTER;
                    Column.mask |= LVCF_FMT;
                }
            } else if(strcmp(option, "-width") == 0) {
                next_i = i + 1;
                Column.cx = SvIV(ST(next_i));
                Column.mask |= LVCF_WIDTH;
            } else if(strcmp(option, "-index") == 0
            || strcmp(option, "-item") == 0) {
                next_i = i + 1;
                iCol = SvIV(ST(next_i));
            } else if(strcmp(option, "-subitem") == 0) {
                next_i = i + 1;
                Column.iSubItem = SvIV(ST(next_i));
                Column.mask |= LVCF_SUBITEM;
            } else if(strcmp(option, "-image") == 0) {
                next_i = i + 1;
                Column.iImage = SvIV(ST(next_i));
                Column.mask |= LVCF_IMAGE;
            }
        } else {
            next_i = -1;
        }
    }
    if(!Column.mask & LVCF_FMT) {
        Column.fmt = LVCFMT_LEFT;
        Column.mask |= LVCF_FMT;
    }
    // evtl. autofill iCol too...

    RETVAL = ListView_InsertColumn(handle, iCol, &Column);
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:InsertItem(%OPTIONS)
    # Inserts a new item in the control.
    # (@)OPT: -image => NUMBER
    # (@)OPT:   index of an image from the associated ImageList
    # (@)OPT: -indent => NUMBER
    # (@)OPT:   how much the item must be indented; one unit
	# (@)OPT:   is the width of an item image, so 2 is twice
	# (@)OPT:   the width of the image, and so on.
	# (@)OPT: -item => NUMBER
	# (@)OPT:   zero-based index for the new item; the default
	# (@)OPT:   is to add the item at the end of the list.
	# (@)OPT: -selected => 0/1, default 0
	# (@)OPT: -text => STRING
	# (@)OPT:   the text for the item
int
InsertItem(handle,...)
    HWND handle
PREINIT:
    LV_ITEM Item;
    unsigned int tlen;
    int i, next_i;
    char * option;
    AV* texts;
	SV** t;
CODE:
	texts = NULL;
    ZeroMemory(&Item, sizeof(LV_ITEM));
	Item.iItem = ListView_GetItemCount(handle);
    next_i = -1;
    for(i = 1; i < items; i++) {
        if(next_i == -1) {
            option = SvPV_nolen(ST(i));
            if(strcmp(option, "-text") == 0) {
				next_i = i + 1;
                if(SvROK(ST(next_i)) && SvTYPE(SvRV(ST(next_i))) == SVt_PVAV) {
                    texts = (AV*)SvRV(ST(next_i));
					t = av_fetch(texts, 0, 0);
					if(t != NULL) {
						Item.pszText = SvPV(*t, tlen);
						Item.cchTextMax = tlen;
						SwitchBit(Item.mask, LVIF_TEXT, 1);
					}
				} else {
					Item.pszText = SvPV(ST(next_i), tlen);
					Item.cchTextMax = tlen;
					SwitchBit(Item.mask, LVIF_TEXT, 1);
				}
            } else if(strcmp(option, "-item") == 0
            || strcmp(option, "-index") == 0) {
                next_i = i + 1;
                Item.iItem = SvIV(ST(next_i));
            } else if(strcmp(option, "-image") == 0) {
                next_i = i + 1;
                Item.iImage = SvIV(ST(next_i));
				SwitchBit(Item.mask, LVIF_IMAGE, 1);
            } else if(strcmp(option, "-selected") == 0) {
                next_i = i + 1;
				SwitchBit(Item.state, LVIS_SELECTED, SvIV(ST(next_i)));
				SwitchBit(Item.stateMask, LVIS_SELECTED, 1);
				SwitchBit(Item.mask, LVIF_STATE, 1);
            } else if(strcmp(option, "-indent") == 0) {
                next_i = i + 1;
                Item.iIndent = SvIV(ST(next_i));
				SwitchBit(Item.mask, LVIF_INDENT, 1);
			}
        } else {
            next_i = -1;
        }
    }
    RETVAL = ListView_InsertItem(handle, &Item);
	if(texts != NULL) {
		for(i=1; i<=av_len(texts); i++) {
			t = av_fetch(texts, i, 0);
			if(t != NULL) {
				Item.pszText = SvPV(*t, tlen);
				Item.cchTextMax = tlen;
				SwitchBit(Item.mask, LVIF_TEXT, 1);
			}
			Item.iSubItem = i;
			ListView_SetItem(handle, &Item);
		}
	}
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:Add(ITEM, ITEM .. ITEM)
    # Inserts one or more items in the control; each item must be passed as
    # an hash reference. See InsertItem() for a list of the available
    # key/values of these hashes.
int
Add(handle,...)
    HWND handle
PREINIT:
    LV_ITEM Item;
    unsigned int tlen;
    int item_i, i;
    char * option;
    AV* texts;
	SV** t;
	HV* itemdata;
	SV* sv_option;
	SV* sv_value;
	I32 retlen;
	I32 nitems;
	int iir;
CODE:
	RETVAL = 0;
    for(item_i = 1; item_i < items; item_i++) {
		texts = NULL;
		if(SvROK(ST(item_i)) && SvTYPE(SvRV(ST(item_i))) == SVt_PVHV) {
			ZeroMemory(&Item, sizeof(LV_ITEM));
			Item.iItem = ListView_GetItemCount(handle);
			itemdata = (HV*)SvRV(ST(item_i));
			nitems = hv_iterinit(itemdata);
			while(nitems--) {
				sv_value = hv_iternextsv(itemdata, &option, &retlen);
				if(strcmp(option, "-text") == 0) {
					if(SvROK(sv_value) && SvTYPE(SvRV(sv_value)) == SVt_PVAV) {
						texts = (AV*)SvRV(sv_value);
						t = av_fetch(texts, 0, 0);
						if(t != NULL) {
							Item.pszText = SvPV(*t, tlen);
							Item.cchTextMax = tlen;
							SwitchBit(Item.mask, LVIF_TEXT, 1);
						}
					} else {
						Item.pszText = SvPV(sv_value, tlen);
						Item.cchTextMax = tlen;
						SwitchBit(Item.mask, LVIF_TEXT, 1);
					}
				} else if(strcmp(option, "-item") == 0
				|| strcmp(option, "-index") == 0) {
					Item.iItem = SvIV(sv_value);
				} else if(strcmp(option, "-image") == 0) {
					Item.iImage = SvIV(sv_value);
					SwitchBit(Item.mask, LVIF_IMAGE, 1);
				} else if(strcmp(option, "-selected") == 0) {
					SwitchBit(Item.state, LVIS_SELECTED, SvIV(sv_value));
					SwitchBit(Item.stateMask, LVIS_SELECTED, 1);
					SwitchBit(Item.mask, LVIF_STATE, 1);
				} else if(strcmp(option, "-indent") == 0) {
					Item.iIndent = SvIV(sv_value);
					SwitchBit(Item.mask, LVIF_INDENT, 1);
				}
			}
		}
		iir = ListView_InsertItem(handle, &Item);
		if(iir != -1) RETVAL++;
		if(texts != NULL) {
			for(i=1; i<=av_len(texts); i++) {
				t = av_fetch(texts, i, 0);
				if(t != NULL) {
					Item.pszText = SvPV(*t, tlen);
					Item.cchTextMax = tlen;
					SwitchBit(Item.mask, LVIF_TEXT, 1);
				}
				Item.iSubItem = i;
				ListView_SetItem(handle, &Item);
			}
		}
		Item.iItem = ListView_GetItemCount(handle);
	}
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:ChangeItem(%OPTIONS)

    ###########################################################################
    # (@)METHOD:SetItem(%OPTIONS)
    # See ChangeItem().
int
ChangeItem(handle,...)
    HWND handle
ALIAS:
    Win32::GUI::ListView::SetItem = 1
PREINIT:
    LV_ITEM Item;
    unsigned int tlen;
    int i, next_i;
    char * option;
CODE:
    ZeroMemory(&Item, sizeof(LV_ITEM));
    next_i = -1;
    for(i = 1; i < items; i++) {
        if(next_i == -1) {
            option = SvPV_nolen(ST(i));
            if(strcmp(option, "-text") == 0) {
                next_i = i + 1;
                Item.pszText = SvPV(ST(next_i), tlen);
                Item.cchTextMax = tlen;
                Item.mask = Item.mask | LVIF_TEXT;
            } else if(strcmp(option, "-item") == 0
            || strcmp(option, "-index") == 0) {
                next_i = i + 1;
                Item.iItem = SvIV(ST(next_i));
            } else if(strcmp(option, "-subitem") == 0) {
                next_i = i + 1;
                Item.iSubItem = SvIV(ST(next_i));
            } else if(strcmp(option, "-image") == 0) {
                next_i = i + 1;
                Item.iImage = SvIV(ST(next_i));
                Item.mask = Item.mask | LVIF_IMAGE;
            }
        } else {
            next_i = -1;
        }
    }
    RETVAL = ListView_SetItem(handle, &Item);
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:ItemInfo(INDEX, [SUBINDEX])
    # Returns an associative array of information about the given zero-based
    # INDEX item:
	#     -image
	#     -state
    #     -text
	# Optionally, a SUBINDEX (one-based index) can be given, to get the text
	# for the specified column.

    ###########################################################################
    # (@)METHOD:GetItem(INDEX, [SUBINDEX])
    # See ItemInfo().
void
ItemInfo(handle,item, subitem=0)
    HWND handle
    int item
    int subitem
ALIAS:
    Win32::GUI::ListView::GetItem = 1
PREINIT:
    LV_ITEM lv_item;
    char pszText[1024];
PPCODE:
    ZeroMemory(&lv_item, sizeof(LV_ITEM));
    lv_item.iItem = item;
    lv_item.mask = LVIF_IMAGE
                 | LVIF_PARAM
                 | LVIF_TEXT | LVIF_STATE;
    lv_item.pszText = pszText;
    lv_item.cchTextMax = 1024;
    lv_item.iSubItem = subitem;
    if(ListView_GetItem(handle, &lv_item)) {
        EXTEND(SP, 6);
        XST_mPV(0, "-text");
        XST_mPV(1, lv_item.pszText);
        XST_mPV(2, "-image");
        XST_mIV(3, lv_item.iImage);
		XST_mPV(4, "-state");
		XST_mIV(5, lv_item.state);
        XSRETURN(6);
    } else {
        XSRETURN_UNDEF;
    }


    ###########################################################################
    # (@)METHOD:View([MODE])
long
View(handle,view=-1)
    HWND handle
    DWORD view
PREINIT:
    DWORD dwStyle;
    DWORD dwView;
CODE:
    // Get the current window style.
    dwStyle = GetWindowLong(handle, GWL_STYLE);
    if(items == 2) {
        // Only set the window style if the view bits have changed.
        if ((dwStyle & LVS_TYPEMASK) != view)
            SetWindowLong(handle, GWL_STYLE,
                          (dwStyle & ~LVS_TYPEMASK) | view);
        dwStyle = GetWindowLong(handle, GWL_STYLE);
        RETVAL = (dwStyle & LVS_TYPEMASK);
    } else
        RETVAL = (dwStyle & LVS_TYPEMASK);
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:Count()
    # Returns the number of items in the ListView.
int
Count(handle)
    HWND handle
CODE:
    RETVAL = ListView_GetItemCount(handle);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:DeleteItem(INDEX)
    # Removes the zero-based INDEX item from the ListView.
BOOL
DeleteItem(handle,index)
    HWND handle
    int index
CODE:
    RETVAL = ListView_DeleteItem(handle, index);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:EditLabel(INDEX)
HWND
EditLabel(handle,index)
    HWND handle
    int index
CODE:
    RETVAL = ListView_EditLabel(handle, index);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:Clear()
    # Deletes all items from the ListView.
BOOL
Clear(handle)
    HWND handle
CODE:
    RETVAL = ListView_DeleteAllItems(handle);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:DeleteColumn(INDEX)
BOOL
DeleteColumn(handle,index)
    HWND handle
    int index
CODE:
    RETVAL = ListView_DeleteColumn(handle, index);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:SelectCount()
UINT
SelectCount(handle)
    HWND handle
CODE:
    RETVAL = ListView_GetSelectedCount(handle);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:Select(INDEX)
void
Select(handle,item)
    HWND handle
    int item
PREINIT:
    UINT state;
    UINT mask;
CODE:
    state = LVIS_FOCUSED | LVIS_SELECTED;
    mask = 0xFFFFFFFF;
    ListView_SetItemState(handle, item, state, mask);

    ###########################################################################
    # (@)METHOD:HitTest(X, Y)
void
HitTest(handle,x,y)
    HWND handle
    LONG x
    LONG y
PREINIT:
    LV_HITTESTINFO ht;
PPCODE:
    ht.pt.x = x;
    ht.pt.y = y;
    ListView_HitTest(handle, &ht);
    if(GIMME == G_ARRAY) {
        EXTEND(SP, 2);
        XST_mIV(0, (long) ht.iItem);
        XST_mIV(1, ht.flags);
        XSRETURN(2);
    } else {
        XSRETURN_IV((long) ht.iItem);
    }

    ###########################################################################
    # (@)METHOD:GetStringWidth(STRING)
int
GetStringWidth(handle,string)
    HWND handle
    LPCSTR string
CODE:
    RETVAL = ListView_GetStringWidth(handle, string);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:GetFirstVisible()
    # Returns the index of the first visible item in the ListView.
int
GetFirstVisible(handle)
    HWND handle
CODE:
    RETVAL = ListView_GetTopIndex(handle);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:EnsureVisible(INDEX, [FLAG])
BOOL
EnsureVisible(handle,index,flag=TRUE)
    HWND handle
    int index
    BOOL flag
CODE:
    RETVAL = ListView_EnsureVisible(handle, index, flag);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:SetImageList(IMAGELIST, [TYPE])
HIMAGELIST
SetImageList(handle,imagelist,type=LVSIL_NORMAL)
    HWND handle
    HIMAGELIST imagelist
    WPARAM type
CODE:
    RETVAL = ListView_SetImageList(handle, imagelist, type);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:TextColor([COLOR])
    # Gets or sets the text color for the ListView.
COLORREF
TextColor(handle,color=-1)
    HWND handle
    COLORREF color
CODE:
    if(items == 2) {
        if(ListView_SetTextColor(handle, color))
            RETVAL = ListView_GetTextColor(handle);
        else
            RETVAL = -1;
    } else
        RETVAL = ListView_GetTextColor(handle);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:TextBkColor([COLOR])
    # Gets or sets the background color for the text in the ListView.
COLORREF
TextBkColor(handle,color=-1)
    HWND handle
    COLORREF color
CODE:
    if(items == 2) {
        if(ListView_SetTextBkColor(handle, color))
            RETVAL = ListView_GetTextBkColor(handle);
        else
            RETVAL = -1;
    } else
        RETVAL = ListView_GetTextBkColor(handle);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:ColumnWidth(COLUMN, [WIDTH])
    # Gets or sets the width of the specified COLUMN; WIDTH can be the desired
    # width in pixels or one of the following special values:
    #   -1 automatically size the column
    #   -2 automatically size the column to fit the header text
int
ColumnWidth(handle,column,width=-1)
    HWND handle
    int column
    int width
CODE:
    if(items == 2)
        RETVAL = ListView_GetColumnWidth(handle, column);
    else
        RETVAL = ListView_SetColumnWidth(handle, column, width);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:VisibleCount()
int
VisibleCount(handle)
    HWND handle
CODE:
    RETVAL = ListView_GetCountPerPage(handle);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:MoveItem(INDEX, X, Y)
BOOL
MoveItem(handle, index, x, y)
    HWND handle
    int index
    int x
    int y
CODE:
    RETVAL = ListView_SetItemPosition(handle, index, x, y);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:ItemPosition(INDEX, [X, Y])
void
ItemPosition(handle, index, x=-1, y=-1)
    HWND handle
    int index
    int x
    int y
PREINIT:
    POINT p;
PPCODE:
    if(items == 2) {
        if(ListView_GetItemPosition(handle, index, &p)) {
            EXTEND(SP, 2);
            XST_mIV(0, p.x);
            XST_mIV(1, p.y);
            XSRETURN(2);
        } else {
            XSRETURN_UNDEF;
        }
    } else {
        XSRETURN_IV(ListView_SetItemPosition(handle, index, x, y));
    }

    ###########################################################################
    # (@)METHOD:Arrange([FLAG])
int
Arrange(handle,flag=LVA_DEFAULT)
    HWND handle
    UINT flag
CODE:
    RETVAL = ListView_Arrange(handle, flag);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:ItemCheck(INDEX)
BOOL
ItemCheck(handle,index,value=FALSE)
    HWND handle
    int index
    BOOL value
PREINIT:
    LVITEM lvitem;
CODE:
    if(items == 3) {
		RETVAL = ListView_GetCheckState(handle, index);
		ListView_SetItemState(handle, index, INDEXTOSTATEIMAGEMASK((value ? 2 : 1)), LVIS_STATEIMAGEMASK);
		# lvitem.mask = LVIF_STATE;
		# lvitem.iItem = index;
		# lvitem.stateMask = LVIS_STATEIMAGEMASK;
		# lvitem.state = INDEXTOSTATEIMAGEMASK((value ? 2 : 1));
		# RETVAL = ListView_SetItem(handle, &lvitem);
    } else {
        RETVAL = ListView_GetCheckState(handle, index);
        # lvitem.mask = LVIF_STATE;
        # lvitem.iItem = index;
        # lvitem.stateMask = LVIS_STATEIMAGEMASK;
        # ListView_GetItem(handle, &lvitem);
        # RETVAL = ((BOOL)(lvitem.state >> 12) -1);
    }
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:SelectedItems()
    # Retuns an array containing the zero-based indexes of selected items.
void
SelectedItems(handle)
    HWND handle
PREINIT:
    LVITEM lvitem;
	UINT lresult;
	UINT scount;
	UINT tcount;
	int index;
PPCODE:
	scount = ListView_GetSelectedCount(handle);
	if(scount > 0) {
		index = -1;
		tcount = 0;
		EXTEND(SP, scount);
		index = ListView_GetNextItem(handle, index, LVNI_SELECTED);
		while(tcount < scount && index != -1) {
			XST_mIV(tcount, (long) index);
			tcount++;
			index = ListView_GetNextItem(handle, index, LVNI_SELECTED);
		}
		XSRETURN(scount);
	} else {
		XSRETURN_UNDEF;
	}

	# TODO: GetItem
	# TODO: GetNextItem

