
#include "GUI.h"

	/*
    ###########################################################################
    # (@)PACKAGE:Win32::GUI::NotifyIcon
    ###########################################################################
	*/

MODULE = Win32::GUI::NotifyIcon		PACKAGE = Win32::GUI::NotifyIcon

    ###########################################################################
    # (@)INTERNAL:Add(PARENT, %OPTIONS)
BOOL
Add(parent,...)
    HWND parent
PREINIT:
    int i, next_i;
    char * option;
    NOTIFYICONDATA nid;
CODE:
    ZeroMemory(&nid, sizeof(NOTIFYICONDATA));
    nid.cbSize = sizeof(NOTIFYICONDATA);
    nid.hWnd = parent;
    nid.uCallbackMessage = WM_NOTIFYICON;
    SwitchBit(nid.uFlags, NIF_MESSAGE, 1);
    next_i = -1;
    for(i = 1; i < items; i++) {
        if(next_i == -1) {
            option = SvPV_nolen(ST(i));
            if(strcmp(option, "-id") == 0) {
                next_i = i + 1;
                nid.uID = (UINT) SvIV(ST(next_i));
            } else if(strcmp(option, "-icon") == 0) {
                next_i = i + 1;
                nid.hIcon = (HICON) handle_From(NOTXSCALL ST(next_i));
                SwitchBit(nid.uFlags, NIF_ICON, 1);
            } else if(strcmp(option, "-tip") == 0) {
                next_i = i + 1;
                strcpy(nid.szTip, SvPV_nolen(ST(next_i)));
                SwitchBit(nid.uFlags, NIF_TIP, 1);
            }
        } else {
            next_i = -1;
        }
    }
    RETVAL = Shell_NotifyIcon(NIM_ADD, &nid);
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)INTERNAL:Modify(PARENT, %OPTIONS)
BOOL
Modify(parent,...)
    HWND parent
PREINIT:
    int i, next_i;
    char * option;
    NOTIFYICONDATA nid;
CODE:
    ZeroMemory(&nid, sizeof(NOTIFYICONDATA));
    nid.cbSize = sizeof(NOTIFYICONDATA);
    nid.hWnd = parent;
    next_i = -1;
    for(i = 1; i < items; i++) {
        if(next_i == -1) {
            option = SvPV_nolen(ST(i));
            if(strcmp(option, "-id") == 0) {
                next_i = i + 1;
                nid.uID = (UINT) SvIV(ST(next_i));
            } else if(strcmp(option, "-icon") == 0) {
                next_i = i + 1;
                nid.hIcon = (HICON) handle_From(NOTXSCALL ST(next_i));
                SwitchBit(nid.uFlags, NIF_ICON, 1);
            } else if(strcmp(option, "-tip") == 0) {
                next_i = i + 1;
                strcpy(nid.szTip, SvPV_nolen(ST(next_i)));
                SwitchBit(nid.uFlags, NIF_TIP, 1);
            }
        } else {
            next_i = -1;
        }
    }
    RETVAL = Shell_NotifyIcon(NIM_MODIFY, &nid);
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)INTERNAL:Delete(PARENT, %OPTIONS)
BOOL
Delete(parent,...)
    HWND parent
PREINIT:
    int i, next_i;
    char * option;
    NOTIFYICONDATA nid;
CODE:
    ZeroMemory(&nid, sizeof(NOTIFYICONDATA));
    nid.cbSize = sizeof(NOTIFYICONDATA);
    nid.hWnd = parent;
    next_i = -1;
    for(i = 1; i < items; i++) {
        if(next_i == -1) {
            option = SvPV_nolen(ST(i));
            if(strcmp(option, "-id") == 0) {
                next_i = i + 1;
                nid.uID = (UINT) SvIV(ST(next_i));
            } else if(strcmp(option, "-icon") == 0) {
                next_i = i + 1;
                nid.hIcon = (HICON) handle_From(NOTXSCALL ST(next_i));
                SwitchBit(nid.uFlags, NIF_ICON, 1);
            } else if(strcmp(option, "-tip") == 0) {
                next_i = i + 1;
                strcpy(nid.szTip, SvPV_nolen(ST(next_i)));
                SwitchBit(nid.uFlags, NIF_TIP, 1);
            }
        } else {
            next_i = -1;
        }
    }
    RETVAL = Shell_NotifyIcon(NIM_DELETE, &nid);
OUTPUT:
    RETVAL
