	/*
    ###########################################################################
    # (@)PACKAGE:Win32::GUI::Rebar
    ###########################################################################
	*/

#include "GUI.h"

BOOL
Rebar_onParseOption(NOTXSPROC char *option, SV* value, LPPERLWIN32GUI_CREATESTRUCT perlcs) {
	BOOL retval;
	retval = FALSE;
	if(strcmp(option, "-imagelist") == 0) {
		retval = TRUE;
		perlcs->hImageList = (HIMAGELIST) handle_From(NOTXSCALL value);
	} else BitmaskOptionValue("-bandborders", perlcs->cs.style, RBS_BANDBORDERS)
	} else BitmaskOptionValue("-fixedorder",  perlcs->cs.style, RBS_FIXEDORDER)
	} else BitmaskOptionValue("-varheight",   perlcs->cs.style, RBS_VARHEIGHT)
	} else BitmaskOptionValue("-autosize",    perlcs->cs.style, RBS_AUTOSIZE)
	} else BitmaskOptionValue("-vertical",    perlcs->cs.style, CCS_VERT)
	} else BitmaskOptionValue("-doubleclick", perlcs->cs.style, RBS_DBLCLKTOGGLE)
	} else BitmaskOptionValue("-vgripper",    perlcs->cs.style, RBS_VERTICALGRIPPER)
	}
	return retval;
}

void
Rebar_onPostCreate(NOTXSPROC HWND myhandle, LPPERLWIN32GUI_CREATESTRUCT perlcs) {
	// initialize and send the REBARINFO structure.
	REBARINFO rbi;
	rbi.cbSize = sizeof(REBARINFO);
	if(perlcs->hImageList != NULL) {
		rbi.fMask = RBIM_IMAGELIST;
		rbi.himl = perlcs->hImageList;
	} else {
		rbi.fMask = 0;
		rbi.himl = NULL;
	}
	SendMessage(myhandle, RB_SETBARINFO, 0, (LPARAM) &rbi);
}


MODULE = Win32::GUI::Rebar		PACKAGE = Win32::GUI::Rebar

    ###########################################################################
    # (@)METHOD:InsertBand(%OPTIONS)
LRESULT
InsertBand(handle,...)
    HWND handle
PREINIT:
    REBARBANDINFO rbbi;
    int i, next_i;
    UINT index;
CODE:
    ZeroMemory(&rbbi, sizeof(REBARBANDINFO));
    rbbi.cbSize = sizeof(REBARBANDINFO);
    index = -1;
    next_i = -1;
    for(i = 1; i < items; i++) {
        if(next_i == -1) {
            if(strcmp(SvPV_nolen(ST(i)), "-image") == 0) {
                next_i = i + 1;
                rbbi.iImage = SvIV(ST(next_i));
                SwitchBit(rbbi.fMask, RBBIM_IMAGE, 1);
            } else if(strcmp(SvPV_nolen(ST(i)), "-index") == 0) {
                next_i = i + 1;
                index = (UINT) SvIV(ST(next_i));
            } else if(strcmp(SvPV_nolen(ST(i)), "-bitmap") == 0) {
                next_i = i + 1;
                rbbi.hbmBack = (HBITMAP) handle_From(NOTXSCALL ST(next_i));
                SwitchBit(rbbi.fMask, RBBIM_BACKGROUND, 1);
            } else if(strcmp(SvPV_nolen(ST(i)), "-child") == 0) {
                next_i = i + 1;
                rbbi.hwndChild = (HWND) handle_From(NOTXSCALL ST(next_i));
                SwitchBit(rbbi.fMask, RBBIM_CHILD, 1);
            } else if(strcmp(SvPV_nolen(ST(i)), "-foreground") == 0) {
                next_i = i + 1;
                rbbi.clrFore = SvCOLORREF(NOTXSCALL ST(next_i));
                SwitchBit(rbbi.fMask, RBBIM_COLORS, 1);
            } else if(strcmp(SvPV_nolen(ST(i)), "-background") == 0) {
                next_i = i + 1;
                rbbi.clrBack = SvCOLORREF(NOTXSCALL ST(next_i));
                SwitchBit(rbbi.fMask, RBBIM_COLORS, 1);
            } else if(strcmp(SvPV_nolen(ST(i)), "-width") == 0) {
                next_i = i + 1;
                rbbi.cx = SvIV(ST(next_i));
                SwitchBit(rbbi.fMask, RBBIM_SIZE, 1);
            } else if(strcmp(SvPV_nolen(ST(i)), "-minwidth") == 0) {
                next_i = i + 1;
                rbbi.cxMinChild = SvIV(ST(next_i));
                SwitchBit(rbbi.fMask, RBBIM_CHILDSIZE, 1);
            } else if(strcmp(SvPV_nolen(ST(i)), "-minheight") == 0) {
                next_i = i + 1;
                rbbi.cyMinChild = SvIV(ST(next_i));
                SwitchBit(rbbi.fMask, RBBIM_CHILDSIZE, 1);
            } else if(strcmp(SvPV_nolen(ST(i)), "-text") == 0) {
                next_i = i + 1;
                rbbi.lpText = SvPV_nolen(ST(next_i));
                SwitchBit(rbbi.fMask, RBBIM_TEXT, 1);
            }
        } else {
            next_i = -1;
        }
    }
    RETVAL = SendMessage(handle, RB_INSERTBAND, (WPARAM) index, (LPARAM) &rbbi);
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:DeleteBand(INDEX)
LRESULT
DeleteBand(handle,index)
    HWND handle
    UINT index
CODE:
    RETVAL = SendMessage(handle, RB_DELETEBAND, (WPARAM) index, 0);
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:RowCount()
LRESULT
RowCount(handle)
    HWND handle
CODE:
    RETVAL = SendMessage(handle, RB_GETROWCOUNT, 0, 0);
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:BandCount()
LRESULT
BandCount(handle)
    HWND handle
CODE:
    RETVAL = SendMessage(handle, RB_GETBANDCOUNT, 0, 0);
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:BandInfo(INDEX)
LRESULT
BandInfo(handle,index)
    HWND handle
    UINT index
PREINIT:
    REBARBANDINFO rbbi;
    int i, next_i;
CODE:
    ZeroMemory(&rbbi, sizeof(REBARBANDINFO));
    rbbi.cbSize = sizeof(REBARBANDINFO);
    rbbi.fMask =
    	RBBIM_BACKGROUND | RBBIM_CHILD | RBBIM_CHILDSIZE | RBBIM_COLORS |
    	RBBIM_HEADERSIZE | RBBIM_IDEALSIZE | RBBIM_ID | RBBIM_IMAGE |
    	RBBIM_LPARAM | RBBIM_SIZE | RBBIM_STYLE | RBBIM_TEXT;
    if(SendMessage(handle, RB_GETBANDINFO, (WPARAM) index, (LPARAM) &rbbi)) {
        EXTEND(SP, 18);
        XST_mPV( 0, "-text");
        XST_mPV( 1, rbbi.lpText);
        XST_mPV( 2, "-foreground");
        XST_mIV( 3, rbbi.clrFore);
		XST_mPV( 4, "-background");
		XST_mIV( 5, rbbi.clrBack);
		XST_mPV( 6, "-image");
		XST_mIV( 7, rbbi.iImage);
		XST_mPV( 8, "-child");
		XST_mIV( 9, (long) rbbi.hwndChild);
		XST_mPV(10, "-bitmap");
		XST_mIV(11, (long) rbbi.hbmBack);
		XST_mPV(12, "-width");
		XST_mIV(13, rbbi.cx);
		XST_mPV(14, "-minwidth");
		XST_mIV(15, rbbi.cxMinChild);
		XST_mPV(16, "-minheight");
		XST_mIV(17, rbbi.cyMinChild);
        XSRETURN(18);
    } else {
        XSRETURN_UNDEF;
    }

    ###########################################################################
    # (@)METHOD:MinimizeBand(INDEX)
LRESULT
MinimizeBand(handle,index)
    HWND handle
    UINT index
CODE:
    RETVAL = SendMessage(handle, RB_MINIMIZEBAND, (WPARAM) index, 0);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:MaximizeBand(INDEX, [FLAG])
LRESULT
MaximizeBand(handle,index,flag=0)
    HWND handle
    UINT index
    BOOL flag
CODE:
    RETVAL = SendMessage(handle, RB_MAXIMIZEBAND, (WPARAM) index, (LPARAM) flag);
OUTPUT:
    RETVAL


    # TODO: ChangeBand

