
	/*
	###########################################################################
    # (@)PACKAGE:Win32::GUI::Splitter
    ###########################################################################
	*/

#include "GUI.h"

BOOL
Splitter_onParseOption(NOTXSPROC char *option, SV* value, LPPERLWIN32GUI_CREATESTRUCT perlcs) {
	BOOL retval;
	SV* storing;
	SV** stored;
	retval = FALSE;
	if(strcmp(option, "-horizontal") == 0) {
		retval = TRUE;
		if(SvIV(value)) {
			perlcs->cs.lpszClass = "Win32::GUI::Splitter(horizontal)";
		} else {
			perlcs->cs.lpszClass = "Win32::GUI::Splitter(vertical)";
		}
		SwitchBit(perlcs->dwPlStyle, PERLWIN32GUI_HORIZONTAL, SvIV(value));
	} else if(strcmp(option, "-min") == 0) {
		retval = TRUE;
		storing = newSViv((LONG) SvIV(value));
		stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-min", 4, storing, 0);
		perlcs->iMinWidth = SvIV(value);
	} else if(strcmp(option, "-max") == 0) {
		retval = TRUE;
		storing = newSViv((LONG) SvIV(value));
		stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-max", 4, storing, 0);
		perlcs->iMaxWidth = SvIV(value);
	} else if(strcmp(option, "-range") == 0) {
		retval = TRUE;
		if(SvROK(value) && SvTYPE(SvRV(value)) == SVt_PVAV) {
			SV** t;
			t = av_fetch((AV*)SvRV(value), 0, 0);
			if(t != NULL) {
				storing = newSViv((LONG) SvIV(*t));
				stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-min", 4, storing, 0);
				perlcs->iMinWidth = SvIV(*t);
			}
			t = av_fetch((AV*)SvRV(value), 1, 0);
			if(t != NULL) {
				storing = newSViv((LONG) SvIV(*t));
				stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-max", 4, storing, 0);
				perlcs->iMaxWidth = SvIV(*t);
			}
		} else {
			if(PL_dowarn)
				warn("Win32::GUI: Argument to -range is not an array reference!");
		}
	}
	return retval;
}


MODULE = Win32::GUI::Splitter		PACKAGE = Win32::GUI::Splitter

PROTOTYPES: DISABLE


void
Min(handle,...)
    HWND handle
PREINIT:
    LPPERLWIN32GUI_USERDATA perlud;
PPCODE:
    if(items > 2) {
        CROAK("Usage: Min(handle, [value]);\n");
    }
	perlud = (LPPERLWIN32GUI_USERDATA) GetWindowLong(handle, GWL_USERDATA);
	if( ValidUserData(perlud) ) {
		if(items == 1) {
			XSRETURN_IV(perlud->iMinWidth);
		} else {
			perlud->iMinWidth = SvIV(ST(1));
			XSRETURN_YES;
		}
	} else {
		XSRETURN_UNDEF;
	}


void
Max(handle,...)
    HWND handle
PREINIT:
    LPPERLWIN32GUI_USERDATA perlud;
PPCODE:
    if(items > 2) {
        CROAK("Usage: Max(handle, [value]);\n");
    }
	perlud = (LPPERLWIN32GUI_USERDATA) GetWindowLong(handle, GWL_USERDATA);
	if( ValidUserData(perlud) ) {
		if(items == 1) {
			XSRETURN_IV(perlud->iMaxWidth);
		} else {
			perlud->iMaxWidth = SvIV(ST(1));
			XSRETURN_YES;
		}
	} else {
		XSRETURN_UNDEF;
	}


void
Horizontal(handle,...)
    HWND handle
PREINIT:
    LPPERLWIN32GUI_USERDATA perlud;
PPCODE:
    if(items > 2) {
        CROAK("Usage: Horizontal(handle, [value]);\n");
    }
	perlud = (LPPERLWIN32GUI_USERDATA) GetWindowLong(handle, GWL_USERDATA);
	if( ValidUserData(perlud) ) {
		if(items == 1) {
			XSRETURN_IV(perlud->dwPlStyle & PERLWIN32GUI_HORIZONTAL);
		} else {
			SwitchBit(perlud->dwPlStyle, PERLWIN32GUI_HORIZONTAL, SvIV(ST(1)));
			SetWindowLong(handle, GWL_USERDATA, (LONG) perlud);
			XSRETURN_YES;
		}
	} else {
		XSRETURN_UNDEF;
	}


void
Vertical(handle,...)
    HWND handle
PREINIT:
    LPPERLWIN32GUI_USERDATA perlud;
PPCODE:
    if(items > 2) {
        CROAK("Usage: Vertical(handle, [value]);\n");
    }
	perlud = (LPPERLWIN32GUI_USERDATA) GetWindowLong(handle, GWL_USERDATA);
	if( ValidUserData(perlud) ) {
		if(items == 1) {
			XSRETURN_IV(!(perlud->dwPlStyle & PERLWIN32GUI_HORIZONTAL));
		} else {
			SwitchBit(perlud->dwPlStyle, PERLWIN32GUI_HORIZONTAL, !SvIV(ST(1)));
			SetWindowLong(handle, GWL_USERDATA, (LONG) perlud);
			XSRETURN_YES;
		}
	} else {
		XSRETURN_UNDEF;
	}
