
#include "GUI.h"

BOOL
Textfield_onParseOption(NOTXSPROC char *option, SV* value, LPPERLWIN32GUI_CREATESTRUCT perlcs) {
	BOOL retval;
	retval = FALSE;
	if(strcmp(option, "-align") == 0) {
		retval = TRUE;
		if(strcmp(SvPV_nolen(value), "left") == 0) {
			SwitchBit(perlcs->cs.style, ES_LEFT, 1);
			SwitchBit(perlcs->cs.style, ES_CENTER, 0);
			SwitchBit(perlcs->cs.style, ES_RIGHT, 0);
		} else if(strcmp(SvPV_nolen(value), "center") == 0) {
			SwitchBit(perlcs->cs.style, ES_LEFT, 0);
			SwitchBit(perlcs->cs.style, ES_CENTER, 1);
			SwitchBit(perlcs->cs.style, ES_RIGHT, 0);
		} else if(strcmp(SvPV_nolen(value), "right") == 0) {
			SwitchBit(perlcs->cs.style, ES_LEFT, 0);
			SwitchBit(perlcs->cs.style, ES_CENTER, 0);
			SwitchBit(perlcs->cs.style, ES_RIGHT, 1);
		} else {
			if(PL_dowarn) warn("Win32::GUI: Invalid value for -align!");
		}
	} else if(strcmp(option, "-multiline") == 0) {
		retval = TRUE;
		if(SvIV(value)) {
			SwitchBit(perlcs->cs.style, ES_MULTILINE, 1);
			SwitchBit(perlcs->cs.style, ES_AUTOHSCROLL, 0);
		} else {
			SwitchBit(perlcs->cs.style, ES_MULTILINE, 0);
			SwitchBit(perlcs->cs.style, ES_AUTOHSCROLL, 1);
		}
	} else BitmaskOptionValue("-keepselection", perlcs->cs.style, ES_NOHIDESEL)
	} else BitmaskOptionValue("-readonly",      perlcs->cs.style, ES_READONLY)
	} else BitmaskOptionValue("-password",      perlcs->cs.style, ES_PASSWORD)
	} else BitmaskOptionValue("-lowercase",     perlcs->cs.style, ES_LOWERCASE)
	} else BitmaskOptionValue("-uppercase",     perlcs->cs.style, ES_UPPERCASE)
	} else BitmaskOptionValue("-autohscroll",   perlcs->cs.style, ES_AUTOHSCROLL)
	} else BitmaskOptionValue("-autovscroll",   perlcs->cs.style, ES_AUTOVSCROLL)
	} else BitmaskOptionValue("-number",        perlcs->cs.style, ES_NUMBER)
	}
	return retval;
}


/*
	###########################################################################
    # (@)PACKAGE:Win32::GUI::Textfield
    ###########################################################################
*/

MODULE = Win32::GUI::Textfield     PACKAGE = Win32::GUI::Textfield

    ###########################################################################
    # (@)METHOD:ReplaceSel(STRING, [FLAG])
LRESULT
ReplaceSel(handle,string,flag=TRUE)
    HWND handle
    LPCTSTR string
    BOOL flag
CODE:
    RETVAL = SendMessage(
        handle, EM_REPLACESEL, (WPARAM) flag, (LPARAM) string
    );
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:ReadOnly([FLAG])
BOOL
ReadOnly(handle,...)
    HWND handle
CODE:
    if(items > 1)
        RETVAL = SendMessage(
            handle, EM_SETREADONLY, (WPARAM) (BOOL) SvIV(ST(1)), 0
        );
    else
        RETVAL = (GetWindowLong(handle, GWL_STYLE) & ES_READONLY);
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:Modified([FLAG])
BOOL
Modified(handle,...)
    HWND handle
CODE:
    if(items > 1)
        RETVAL = SendMessage(
            handle, EM_SETMODIFY, (WPARAM) (UINT) SvIV(ST(1)), 0
        );
    else
        RETVAL = SendMessage(handle, EM_GETMODIFY, 0, 0);
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:Undo()
BOOL
Undo(handle)
    HWND handle
CODE:
    if (SendMessage(handle, EM_CANUNDO, 0, 0))
        RETVAL = SendMessage(handle, EM_UNDO, 0, 0);
    else
        RETVAL = 0;
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:LineFromChar(INDEX)
LRESULT
LineFromChar(handle,index)
    HWND handle
    WPARAM index
CODE:
    RETVAL = SendMessage(handle, EM_EXLINEFROMCHAR, index, 0);
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:PasswordChar([CHAR])
LRESULT
PasswordChar(handle,passchar=0)
    HWND handle
    UINT passchar
CODE:
    if(items == 1) {
        RETVAL = SendMessage(handle, EM_GETPASSWORDCHAR, 0, 0);
    } else {
        RETVAL = SendMessage(handle, EM_SETPASSWORDCHAR, (WPARAM) passchar, 0);
    }
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:Selection()
void
Selection(handle)
    HWND handle
PREINIT:
    DWORD start;
    DWORD end;
PPCODE:
    SendMessage(
        handle, EM_GETSEL, (WPARAM) &start, (LPARAM) &end
    );
    EXTEND(SP, 2);
    XST_mIV(0, (long) start);
    XST_mIV(1, (long) end);
    XSRETURN(2);


    ###########################################################################
    # (@)METHOD:Scroll(COMMAND | LINE | HORIZONTAL, VERTICAL)
LRESULT
Scroll(handle, line, otherdirection=NULL)
    SV* handle
    SV* line
    DWORD otherdirection
PREINIT:
	HWND hwnd;
    WPARAM wparam;
    char *arg;
    POINT pt;
CODE:
	hwnd = handle_From(NOTXSCALL handle);
	if(items == 2) {
		if(SvPOK(line)) {
			arg = strlwr( SvPV_nolen(line) );

			if(0 == strcmp( arg, "bottom" )) {
				RETVAL = SendMessage( hwnd, EM_GETLINECOUNT, 0, 0 );
				wparam = RETVAL;
				RETVAL = SendMessage( hwnd, EM_GETFIRSTVISIBLELINE, 0, 0);
				wparam -= RETVAL;
				RETVAL = SendMessage( hwnd, EM_LINESCROLL, 0, wparam);
			} else if(0 == strcmp( arg, "top" )) {
				wparam = SendMessage( hwnd, EM_GETFIRSTVISIBLELINE, 0, 0);
				RETVAL = SendMessage( hwnd, EM_LINESCROLL, 0, -wparam);
			} else {
				if(0 == strcmp( arg, "up" )) {
					wparam = SB_LINEUP;
				} else if(0 == strcmp( arg, "down" )
				||        0 == strcmp( arg, "dn" )) {
					wparam = SB_LINEDOWN;
				} else if(0 == strcmp( arg, "pageup" )
				||        0 == strcmp( arg, "pgup" )) {
					wparam = SB_PAGEUP;
				} else if(0 == strcmp( arg, "pagedown" )
				||        0 == strcmp( arg, "pagedn" )
				||        0 == strcmp( arg, "pgdown" )
				||        0 == strcmp( arg, "pgdn")) {
					wparam = SB_PAGEDOWN;
				}
				RETVAL = SendMessage(
					hwnd, EM_SCROLL, (WPARAM) wparam, (LPARAM) 0
				);
			}
		} else {
			RETVAL = SendMessage(
				hwnd, EM_LINESCROLL, 0, (WPARAM) SvIV(line)
			);
		}
	} else {
		if(sv_derived_from(handle, "Win32::GUI::RichEdit")) {
			RETVAL = SendMessage(
				hwnd, EM_LINESCROLL, 0, (WPARAM) otherdirection
			);
		} else {
			RETVAL = SendMessage(
				hwnd, EM_LINESCROLL, (LPARAM) SvIV(line), (WPARAM) otherdirection
			);
		}
	}
	SendMessage( handle, EM_SCROLLCARET, 0, 0);
OUTPUT:
	RETVAL


    ###########################################################################
    # (@)METHOD:Append(TEXT)
void
Append(handle, text)
    HWND handle
    char * text
PREINIT:
	int length;
CODE:
	length = GetWindowTextLength(handle);
	SendMessage(handle, EM_SETSEL, length, length);
	SendMessage(handle, EM_REPLACESEL, (WPARAM) TRUE, (LPARAM) text);
