
#include "GUI.h"

	/*
    ###########################################################################
    # (@)PACKAGE:Win32::GUI::Toolbar
    ###########################################################################
	*/


BOOL
Toolbar_onParseOption(NOTXSPROC char *option, SV* value, LPPERLWIN32GUI_CREATESTRUCT perlcs) {
	BOOL retval;
	retval = FALSE;
	if(strcmp(option, "-imagelist") == 0) {
		retval = TRUE;
		perlcs->hImageList = (HIMAGELIST) handle_From(NOTXSCALL value);
	} else BitmaskOptionValue("-flat", perlcs->cs.style, TBSTYLE_FLAT)
	} else BitmaskOptionValue("-nodivider", perlcs->cs.style, CCS_NODIVIDER)
	} else BitmaskOptionValue("-multiline", perlcs->cs.style, TBSTYLE_WRAPABLE)
	}
	return retval;
}

void
Toolbar_onPostCreate(NOTXSPROC HWND myhandle, LPPERLWIN32GUI_CREATESTRUCT perlcs) {
	SendMessage(myhandle, TB_BUTTONSTRUCTSIZE, (WPARAM) sizeof(TBBUTTON), 0);
	/* SendMessage(myhandle, TB_SETIMAGELIST, 0, (LPARAM) perlcs->hImageList); */
}

MODULE = Win32::GUI::Toolbar     PACKAGE = Win32::GUI::Toolbar

    ###########################################################################
    # (@)METHOD:AddBitmap(BITMAP, NUMBUTTONS)
LRESULT
AddBitmap(handle,bitmap,numbuttons)
    HWND handle
    HBITMAP bitmap
    WPARAM numbuttons
PREINIT:
    TBADDBITMAP TbAddBitmap;
CODE:
    TbAddBitmap.hInst = (HINSTANCE) NULL;
    TbAddBitmap.nID = (UINT) bitmap;

    RETVAL = SendMessage(handle, TB_ADDBITMAP, numbuttons,
                         (LPARAM) (LPTBADDBITMAP) &TbAddBitmap);
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:AddString(STRING)
LRESULT
AddString(handle,string)
    HWND handle
    char * string
PREINIT:
    char *Strings;
    int i;
    unsigned int szLen, totLen;
    LPARAM lParam;
CODE:
    totLen = 0;
    #    // the function should accept an array of strings,
    #    // but actually doesn't work...
    #
    #    for(i = 1; i < items; i++) {
    #        Strings = SvPV(ST(i), szLen);
    #        __DEBUG("AddString: szLen(%d) = %d\n", i, szLen);
    #        totLen += szLen+1;
    #    }
    #    totLen++;
    #    __DEBUG("AddString: totLen = %d\n", totLen);
    #    Strings = (char *) safemalloc(totLen);
    #
    #    totLen = 0;
    #    char *tmpStrings = Strings;
    #    for(i = 1; i < items; i++) {
    #        strcat(tmpStrings, SvPV(ST(i), szLen));
    #        totLen += szLen+1;
    #
    #    }
    #    Strings[totLen++] = '\0';
    // only one string allowed
    Strings = SvPV(ST(1), szLen);
    Strings = (char *) safemalloc(szLen+2);
    strcpy(Strings, string);
    Strings[szLen+1] = '\0';
#ifdef PERLWIN32GUI_DEBUG
	printf("XS(Toolbar::AddString): Strings='%s', len=%d\n", Strings, szLen);
#endif
#ifdef PERLWIN32GUI_DEBUG
    for(i=0; i<=szLen+1; i++) {
        printf("XS(Toolbar::AddString): Strings[%d]='%d'\n", i, Strings[i]);
    }
#endif
    lParam = (LPARAM) MAKELONG(Strings, 0);
#ifdef PERLWIN32GUI_DEBUG
	printf("XS(Toolbar::AddString): handle=0x%x\n", handle);
	printf("XS(Toolbar::AddString): Strings=0x%x\n", Strings);
	printf("XS(Toolbar::AddString): lParam=0x%x\n", lParam);
#endif
    RETVAL = SendMessage(handle, TB_ADDSTRING, 0, (LPARAM) Strings);
#ifdef PERLWIN32GUI_DEBUG
	printf("XS(Toolbar::AddString): SendMessage.result=%ld", RETVAL);
#endif
    safefree(Strings);
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:AddButtons(NUMBER, ...)
LRESULT
AddButtons(handle,number,...)
    HWND handle
    UINT number
PREINIT:
    LPTBBUTTON buttons;
    int i, q, b;
CODE:
    if(items != 2 + number * 5) {
        CROAK("AddButtons: wrong number of parameters (expected %d, got %d)!\n", 2+number*5, items);
    }
    buttons = (LPTBBUTTON) safemalloc(sizeof(TBBUTTON)*number);
    q = 0;
    b = 0;
    for(i = 2; i < items; i++) {
        switch(q) {
        case 0:
            buttons[b].iBitmap = (int) SvIV(ST(i));
            break;
        case 1:
            buttons[b].idCommand = (int) SvIV(ST(i));
            break;
        case 2:
            buttons[b].fsState = (BYTE) SvIV(ST(i));
            break;
        case 3:
            buttons[b].fsStyle = (BYTE) SvIV(ST(i));
            break;
        case 4:
            buttons[b].iString = (int) SvIV(ST(i));
        }
        q++;
        if(q == 5) {
            buttons[b].dwData = 0;
            q = 0;
            b++;
        }
    }
    RETVAL = SendMessage(handle, TB_ADDBUTTONS,
                         (WPARAM) number,
                         (LPARAM) (LPTBBUTTON) buttons);
    safefree(buttons);
OUTPUT:
    RETVAL

    # LRESULT
    # AddButton(handle,...)
    #     HWND handle
    # PREINIT:
    #     TBBUTTON button;
    #     TBBUTTONINFO buttoninfo;
    #     int i, next_i;
    #     char *option;
    # CODE:
    #     ZeroMemory(&button, sizeof(TBBUTTON));
    #     ZeroMemory(&buttoninfo, sizeof(TBBUTTONINFO));
    #     buttoninfo.cbSize = sizeof(TBBUTTONINFO);
    #     next_i = -1;
    #     for(i = 2; i < items; i++) {
    #         if(next_i == -1) {
    #             option = SvPV_nolen(ST(i));
    #             if(strcmp(option, "-image") == 0) {
    #                 next_i = i + 1;
    #                 button.iBitmap = SvIV(ST(next_i));
    #             } else
    #             if(strcmp(option, "-text") == 0) {
    #                 next_i = i + 1;
    #                 buttoninfo.dwMask |= TBIF_TEXT;
    #                 buttoninfo.pszText = SvPV_nolen(ST(next_i));
    #             }
    #             // to implement: -style, -state, -id(?)
    #         } else {
    #             next_i = -1;
    #         }
    #     }
    #     RETVAL = FALSE;
    #     # SendMessage(handle, TB_SETBUTTONINFO, (WPARAM) &buttoninfo, 0);
    #     # RETVAL = TabCtrl_SetItem(handle, item, &Item);
    # OUTPUT:
    #     RETVAL


    ###########################################################################
    # (@)INTERNAL:ButtonStructSize()
    # initializes the toolbar button structure size
LRESULT
ButtonStructSize(handle)
    HWND handle
CODE:
    RETVAL = SendMessage(handle, TB_BUTTONSTRUCTSIZE,
                         (WPARAM) sizeof(TBBUTTON), 0);
OUTPUT:
    RETVAL


    ###########################################################################
    # (@)METHOD:ButtonCount()
    # returns the number of buttons in the toolbar
LRESULT
ButtonCount(handle)
    HWND handle
CODE:
    RETVAL = SendMessage(handle, TB_BUTTONCOUNT, 0, 0);
OUTPUT:
    RETVAL

    ###########################################################################
    # (@)METHOD:Padding([X], [Y])
    # gets or sets the padding for the toolbar;
    # if no value is passed, returns a list containing the current x and y
    # padding value, in pixels.
void
Padding(handle,x=-1,y=-1)
    HWND handle
    int x
    int y
PREINIT:
	LRESULT pad;
PPCODE:
	if(items == 1) {
		pad = SendMessage(handle, TB_GETPADDING, 0, 0);
		EXTEND(SP, 2);
		XST_mIV(0, LOWORD(pad));
		XST_mIV(1, HIWORD(pad));
		XSRETURN(2);
	} else {
		if(items == 2) y = x;
		XSRETURN_IV( SendMessage(handle, TB_SETPADDING, 0, MAKELPARAM(x, y)) );
	}

    ###########################################################################
    # (@)METHOD:Indent(VALUE)
    # sets the indentation value for the toolbar
LRESULT
Indent(handle,value)
    HWND handle
    int value
CODE:
	RETVAL = SendMessage(handle, TB_SETINDENT, (WPARAM) value, 0);
OUTPUT:
	RETVAL

    ###########################################################################
    # (@)METHOD:AutoSize()
    # causes the toolbar to be resized
LRESULT
AutoSize(handle)
    HWND handle
CODE:
	RETVAL = SendMessage(handle, TB_AUTOSIZE, 0, 0);
OUTPUT:
	RETVAL

    ###########################################################################
    # (@)METHOD:MaxSize()
    # returns the total size of all the visible buttons and separators in the
    # toolbar (or undef on errors)
void
MaxSize(handle)
    HWND handle
PREINIT:
	SIZE size;
PPCODE:
	if( SendMessage(handle, TB_GETMAXSIZE, 0, (LPARAM) &size) ) {
		EXTEND(SP, 2);
		XST_mIV(0, size.cx);
		XST_mIV(1, size.cy);
		XSRETURN(2);
	} else {
		XSRETURN_UNDEF;
	}


	# TODO: Rows,
