
#define PERLWIN32GUI_OPT_NAME			0x00000001L
#define PERLWIN32GUI_OPT_TEXT			0x00000002L
#define PERLWIN32GUI_OPT_LEFT			0x00000004L
#define PERLWIN32GUI_OPT_TOP			0x00000008L
#define PERLWIN32GUI_OPT_WIDTH			0x00000010L
#define PERLWIN32GUI_OPT_HEIGHT			0x00000020L
#define PERLWIN32GUI_OPT_POS			PERLWIN32GUI_OPT_LEFT | PERLWIN32GUI_OPT_TOP
#define PERLWIN32GUI_OPT_SIZE			PERLWIN32GUI_OPT_WIDTH | PERLWIN32GUI_OPT_HEIGHT
#define PERLWIN32GUI_OPT_CLASS			0x00000040L
#define PERLWIN32GUI_OPT_STYLE			0x00000080L
#define PERLWIN32GUI_OPT_EXSTYLE		0x00000100L
#define PERLWIN32GUI_OPT_PUSHSTYLE		0x00000200L
#define PERLWIN32GUI_OPT_POPSTYLE		0x00000400L
#define PERLWIN32GUI_OPT_PUSHEXSTYLE	PERLWIN32GUI_OPT_EXSTYLE | PERLWIN32GUI_OPT_PUSHSTYLE
#define PERLWIN32GUI_OPT_POPEXSTYLE		PERLWIN32GUI_OPT_EXSTYLE | PERLWIN32GUI_OPT_POPSTYLE
#define PERLWIN32GUI_OPT_PARENT			0x00000800L
#define PERLWIN32GUI_OPT_MENU			0x00001000L
#define PERLWIN32GUI_OPT_INSTANCE 		0x00002000L
#define PERLWIN32GUI_OPT_FONT			0x00004000L
#define PERLWIN32GUI_OPT_VISIBLE		0x00008000L
#define PERLWIN32GUI_OPT_DISABLED		0x00010000L
#define PERLWIN32GUI_OPT_GROUP			0x00020000L
#define PERLWIN32GUI_OPT_TABSTOP		0x00040000L
#define PERLWIN32GUI_OPT_FOREGROUND		0x00080000L
#define PERLWIN32GUI_OPT_BACKGROUND		0x00100000L
#define PERLWIN32GUI_OPT_HSCROLL		0x00200000L
#define PERLWIN32GUI_OPT_VSCROLL		0x00400000L
#define PERLWIN32GUI_OPT_TIP			0x00800000L
#define PERLWIN32GUI_OPT_CONTAINER		0x01000000L
#define PERLWIN32GUI_OPT_EVENTS			0x02000000L
#define PERLWIN32GUI_OPT_MINWIDTH		0x04000000L
#define PERLWIN32GUI_OPT_MINHEIGHT		0x08000000L
#define PERLWIN32GUI_OPT_MAXWIDTH		0x10000000L
#define PERLWIN32GUI_OPT_MAXHEIGHT		0x20000000L
#define PERLWIN32GUI_OPT_MINSIZE		PERLWIN32GUI_OPT_MINWIDTH | PERLWIN32GUI_OPT_MINHEIGHT
#define PERLWIN32GUI_OPT_MAXSIZE		PERLWIN32GUI_OPT_MAXWIDTH | PERLWIN32GUI_OPT_MAXHEIGHT

#define PERLWIN32GUI_OPT_SPECIFIC		0x80000000L

// ##############################
// Win32::GUI::Window & DialogBox
// ##############################
#define PERLWIN32GUI_OPT_TOPMOST		PERLWIN32GUI_OPT_SPECIFIC | 0x00000001L
#define PERLWIN32GUI_OPT_MAXIMIZEBOX	PERLWIN32GUI_OPT_SPECIFIC | 0x00000002L
#define PERLWIN32GUI_OPT_MINIMIZEBOX	PERLWIN32GUI_OPT_SPECIFIC | 0x00000004L
#define PERLWIN32GUI_OPT_RESIZABLE		PERLWIN32GUI_OPT_SPECIFIC | 0x00000008L
#define PERLWIN32GUI_OPT_SYSMENU		PERLWIN32GUI_OPT_SPECIFIC | 0x00000010L
#define PERLWIN32GUI_OPT_HELPBOX		PERLWIN32GUI_OPT_SPECIFIC | 0x00000020L
#define PERLWIN32GUI_OPT_ACCEL			PERLWIN32GUI_OPT_SPECIFIC | 0x00000040L
#define PERLWIN32GUI_OPT_CONTROLPARENT	PERLWIN32GUI_OPT_SPECIFIC | 0x00000080L

// #################
// Win32::GUI::Label
// #################
#define PERLWIN32GUI_OPT_ALIGN			PERLWIN32GUI_OPT_SPECIFIC | 0x00000001L
#define PERLWIN32GUI_OPT_BITMAP			PERLWIN32GUI_OPT_SPECIFIC | 0x00000002L
#define PERLWIN32GUI_OPT_TRUNCATE		PERLWIN32GUI_OPT_SPECIFIC | 0x00000004L
#define PERLWIN32GUI_OPT_FRAME			PERLWIN32GUI_OPT_SPECIFIC | 0x00000008L
#define PERLWIN32GUI_OPT_SUNKEN			PERLWIN32GUI_OPT_SPECIFIC | 0x00000010L
#define PERLWIN32GUI_OPT_WRAP			PERLWIN32GUI_OPT_SPECIFIC | 0x00000020L
#define PERLWIN32GUI_OPT_NOTIFY			PERLWIN32GUI_OPT_SPECIFIC | 0x00000040L
#define PERLWIN32GUI_OPT_FILL			PERLWIN32GUI_OPT_SPECIFIC | 0x00000080L


// ################################
// Win32::GUI::Textfield & RichEdit
// ################################
// -align is handled by Label
#define PERLWIN32GUI_OPT_MULTILINE		PERLWIN32GUI_OPT_SPECIFIC | 0x00000002L
#define PERLWIN32GUI_OPT_KEEPSELECTION	PERLWIN32GUI_OPT_SPECIFIC | 0x00000004L
#define PERLWIN32GUI_OPT_READONLY		PERLWIN32GUI_OPT_SPECIFIC | 0x00000008L
#define PERLWIN32GUI_OPT_PASSWORD		PERLWIN32GUI_OPT_SPECIFIC | 0x00000010L
#define PERLWIN32GUI_OPT_LOWERCASE		PERLWIN32GUI_OPT_SPECIFIC | 0x00000020L
#define PERLWIN32GUI_OPT_UPPERCASE		PERLWIN32GUI_OPT_SPECIFIC | 0x00000040L
#define PERLWIN32GUI_OPT_AUTOHSCROLL	PERLWIN32GUI_OPT_SPECIFIC | 0x00000080L
#define PERLWIN32GUI_OPT_AUTOVSCROLL	PERLWIN32GUI_OPT_SPECIFIC | 0x00000100L
#define PERLWIN32GUI_OPT_NUMBER			PERLWIN32GUI_OPT_SPECIFIC | 0x00000200L


// ##########################################
// Win32::GUI::Button, RadioButton & Checkbox
// ##########################################
// -align is handled by Label
// -bitmap is handled by Label
#define PERLWIN32GUI_OPT_VALIGN			PERLWIN32GUI_OPT_SPECIFIC | 0x00000004L
#define PERLWIN32GUI_OPT_OK				PERLWIN32GUI_OPT_SPECIFIC | 0x00000008L
#define PERLWIN32GUI_OPT_CANCEL			PERLWIN32GUI_OPT_SPECIFIC | 0x00000010L
#define PERLWIN32GUI_OPT_DEFAULT		PERLWIN32GUI_OPT_SPECIFIC | 0x00000020L
#define PERLWIN32GUI_OPT_CHECKED		PERLWIN32GUI_OPT_SPECIFIC | 0x00000040L

// #####################################
// Win32::GUI::Listbox (and Combobox???)
// #####################################
#define PERLWIN32GUI_OPT_MULTISEL		PERLWIN32GUI_OPT_SPECIFIC | 0x00000001L
#define PERLWIN32GUI_OPT_SORT			PERLWIN32GUI_OPT_SPECIFIC | 0x00000002L


// ####################
// Win32::GUI::TabStrip
// ####################
// -multiline is handled by Textfield
#define PERLWIN32GUI_OPT_IMAGELIST		PERLWIN32GUI_OPT_SPECIFIC | 0x00000001L
#define PERLWIN32GUI_OPT_VERTICAL		PERLWIN32GUI_OPT_SPECIFIC | 0x00000004L
#define PERLWIN32GUI_OPT_BOTTOM			PERLWIN32GUI_OPT_SPECIFIC | 0x00000008L
#define PERLWIN32GUI_OPT_TABRIGHT		PERLWIN32GUI_OPT_SPECIFIC | 0x00000010L /* TODO: RIGHT!!! */
#define PERLWIN32GUI_OPT_HOTTRACK		PERLWIN32GUI_OPT_SPECIFIC | 0x00000020L
#define PERLWIN32GUI_OPT_BUTTONS		PERLWIN32GUI_OPT_SPECIFIC | 0x00000040L
#define PERLWIN32GUI_OPT_JUSTIFY		PERLWIN32GUI_OPT_SPECIFIC | 0x00000080L
#define PERLWIN32GUI_OPT_FLAT			PERLWIN32GUI_OPT_SPECIFIC | 0x00000100L

// ###################
// Win32::GUI::Toolbar
// ###################
// -multiline is handled by Textfield
// -imagelist is handled by TabStrip
// -flat is handled by TabStrip
#define PERLWIN32GUI_OPT_NODIVIDER		PERLWIN32GUI_OPT_SPECIFIC | 0x00000004L


typedef struct tagOptionPtr {
	int iPos;
	int iID;
	DWORD dwApply;
} OptionPtr;


static char *gpOptions[65535];
static int gnOptions;
static OptionPtr gOptions[1000];

OptionPtr LoadOption(char *option, int optionID, DWORD apply) {
	OptionPtr opt;
	opt.iPos = strlen((char *)gpOptions);
	opt.iID = optionID;
	opt.dwApply = apply;
//	printf("!XS(LoadOption): option='%s', iPos=%d, iID=0x%x, dwApply=0x%x\n", option, opt.iPos, opt.iID, opt.dwApply);
	strcat((char *)gpOptions, option);
	return opt;
}

void InitOptions() {
	int i;
	i = 0;
	gOptions[i++] = LoadOption("-name", 		PERLWIN32GUI_OPT_NAME, 0);

	gOptions[i++] = LoadOption("-text", 		PERLWIN32GUI_OPT_TEXT, 0);
	gOptions[i++] = LoadOption("-caption", 		PERLWIN32GUI_OPT_TEXT, 0);
	gOptions[i++] = LoadOption("-title", 		PERLWIN32GUI_OPT_TEXT, 0);

	gOptions[i++] = LoadOption("-left", 		PERLWIN32GUI_OPT_LEFT, 0);
	gOptions[i++] = LoadOption("-top",	 		PERLWIN32GUI_OPT_TOP, 0);
	gOptions[i++] = LoadOption("-width", 		PERLWIN32GUI_OPT_LEFT, 0);
	gOptions[i++] = LoadOption("-height", 		PERLWIN32GUI_OPT_TOP, 0);
	gOptions[i++] = LoadOption("-size", 		PERLWIN32GUI_OPT_SIZE, 0);
	gOptions[i++] = LoadOption("-pos", 			PERLWIN32GUI_OPT_POS, 0);
	gOptions[i++] = LoadOption("-class", 		PERLWIN32GUI_OPT_CLASS, 0);
	gOptions[i++] = LoadOption("-style", 		PERLWIN32GUI_OPT_STYLE, 0);
	gOptions[i++] = LoadOption("-exstyle", 		PERLWIN32GUI_OPT_EXSTYLE, 0);

	gOptions[i++] = LoadOption("-pushstyle", 	PERLWIN32GUI_OPT_PUSHSTYLE, 0);
	gOptions[i++] = LoadOption("-addstyle", 	PERLWIN32GUI_OPT_PUSHSTYLE, 0);

	gOptions[i++] = LoadOption("-popstyle", 	PERLWIN32GUI_OPT_POPSTYLE, 0);
	gOptions[i++] = LoadOption("-remstyle", 	PERLWIN32GUI_OPT_POPSTYLE, 0);
	gOptions[i++] = LoadOption("-notstyle", 	PERLWIN32GUI_OPT_POPSTYLE, 0);
	gOptions[i++] = LoadOption("-negstyle", 	PERLWIN32GUI_OPT_POPSTYLE, 0);

	gOptions[i++] = LoadOption("-pushexstyle", 	PERLWIN32GUI_OPT_PUSHEXSTYLE, 0);
	gOptions[i++] = LoadOption("-addexstyle", 	PERLWIN32GUI_OPT_PUSHEXSTYLE, 0);

	gOptions[i++] = LoadOption("-popexstyle", 	PERLWIN32GUI_OPT_POPEXSTYLE, 0);
	gOptions[i++] = LoadOption("-remexstyle", 	PERLWIN32GUI_OPT_POPEXSTYLE, 0);
	gOptions[i++] = LoadOption("-notexstyle", 	PERLWIN32GUI_OPT_POPEXSTYLE, 0);
	gOptions[i++] = LoadOption("-negexstyle", 	PERLWIN32GUI_OPT_POPEXSTYLE, 0);

	// ##############################
	// Win32::GUI::Window & DialogBox
	// ##############################
	gOptions[i++] = LoadOption("-topmost",		PERLWIN32GUI_OPT_TOPMOST,
		PERLWIN32GUI_CLS_WINDOW | PERLWIN32GUI_CLS_DIALOG
	);
	gOptions[i++] = LoadOption("-hasmaximize",		PERLWIN32GUI_OPT_MAXIMIZEBOX,
		PERLWIN32GUI_CLS_WINDOW | PERLWIN32GUI_CLS_DIALOG
	);
	gOptions[i++] = LoadOption("-maximizebox",		PERLWIN32GUI_OPT_MAXIMIZEBOX,
		PERLWIN32GUI_CLS_WINDOW | PERLWIN32GUI_CLS_DIALOG
	);
	gOptions[i++] = LoadOption("-hasminimize",		PERLWIN32GUI_OPT_MINIMIZEBOX,
		PERLWIN32GUI_CLS_WINDOW | PERLWIN32GUI_CLS_DIALOG
	);
	gOptions[i++] = LoadOption("-minimizebox",		PERLWIN32GUI_OPT_MINIMIZEBOX,
		PERLWIN32GUI_CLS_WINDOW | PERLWIN32GUI_CLS_DIALOG
	);
	gOptions[i++] = LoadOption("-sizable",			PERLWIN32GUI_OPT_RESIZABLE,
		PERLWIN32GUI_CLS_WINDOW | PERLWIN32GUI_CLS_DIALOG
	);
	gOptions[i++] = LoadOption("-resizable",		PERLWIN32GUI_OPT_RESIZABLE,
		PERLWIN32GUI_CLS_WINDOW | PERLWIN32GUI_CLS_DIALOG
	);
	gOptions[i++] = LoadOption("-sysmenu",			PERLWIN32GUI_OPT_SYSMENU,
		PERLWIN32GUI_CLS_WINDOW | PERLWIN32GUI_CLS_DIALOG
	);
	gOptions[i++] = LoadOption("-menubox",			PERLWIN32GUI_OPT_SYSMENU,
		PERLWIN32GUI_CLS_WINDOW | PERLWIN32GUI_CLS_DIALOG
	);
	gOptions[i++] = LoadOption("-controlbox",		PERLWIN32GUI_OPT_SYSMENU,
		PERLWIN32GUI_CLS_WINDOW | PERLWIN32GUI_CLS_DIALOG
	);
	gOptions[i++] = LoadOption("-helpbutton",		PERLWIN32GUI_OPT_HELPBOX,
		PERLWIN32GUI_CLS_WINDOW | PERLWIN32GUI_CLS_DIALOG
	);
	gOptions[i++] = LoadOption("-helpbox",			PERLWIN32GUI_OPT_HELPBOX,
		PERLWIN32GUI_CLS_WINDOW | PERLWIN32GUI_CLS_DIALOG
	);
	gOptions[i++] = LoadOption("-hashelp",			PERLWIN32GUI_OPT_HELPBOX,
		PERLWIN32GUI_CLS_WINDOW | PERLWIN32GUI_CLS_DIALOG
	);
	gOptions[i++] = LoadOption("-accel",			PERLWIN32GUI_OPT_ACCEL,
		PERLWIN32GUI_CLS_WINDOW | PERLWIN32GUI_CLS_DIALOG
	);
	gOptions[i++] = LoadOption("-accelerators",		PERLWIN32GUI_OPT_ACCEL,
		PERLWIN32GUI_CLS_WINDOW | PERLWIN32GUI_CLS_DIALOG
	);
	gOptions[i++] = LoadOption("-acceleratortable",	PERLWIN32GUI_OPT_ACCEL,
		PERLWIN32GUI_CLS_WINDOW | PERLWIN32GUI_CLS_DIALOG
	);

	// #################
	// Win32::GUI::Label
	// #################
	gOptions[i++] = LoadOption("-align",			PERLWIN32GUI_OPT_ALIGN,
		PERLWIN32GUI_CLS_STATIC |
		PERLWIN32GUI_CLS_BUTTON | PERLWIN32GUI_CLS_RADIOBUTTON | PERLWIN32GUI_CLS_CHECKBOX |
		PERLWIN32GUI_CLS_EDIT | PERLWIN32GUI_CLS_RICHEDIT
	);
	gOptions[i++] = LoadOption("-bitmap",			PERLWIN32GUI_OPT_BITMAP,
		PERLWIN32GUI_CLS_STATIC |
		PERLWIN32GUI_CLS_BUTTON | PERLWIN32GUI_CLS_RADIOBUTTON | PERLWIN32GUI_CLS_CHECKBOX
	);
	gOptions[i++] = LoadOption("-picture",			PERLWIN32GUI_OPT_BITMAP,
		PERLWIN32GUI_CLS_STATIC |
		PERLWIN32GUI_CLS_BUTTON | PERLWIN32GUI_CLS_RADIOBUTTON | PERLWIN32GUI_CLS_CHECKBOX
	);
	gOptions[i++] = LoadOption("-truncate",			PERLWIN32GUI_OPT_TRUNCATE,
		PERLWIN32GUI_CLS_STATIC
	);
	gOptions[i++] = LoadOption("-frame",			PERLWIN32GUI_OPT_FRAME,
		PERLWIN32GUI_CLS_STATIC
	);
	gOptions[i++] = LoadOption("-sunken",			PERLWIN32GUI_OPT_SUNKEN,
		PERLWIN32GUI_CLS_STATIC
	);
	gOptions[i++] = LoadOption("-wrap",				PERLWIN32GUI_OPT_WRAP,
		PERLWIN32GUI_CLS_STATIC
	);
	gOptions[i++] = LoadOption("-notify",			PERLWIN32GUI_OPT_NOTIFY,
		PERLWIN32GUI_CLS_STATIC
	);

	// ################################
	// Win32::GUI::Textfield & RichEdit
	// ################################
	// -align is handled by Label
	gOptions[i++] = LoadOption("-multiline",		PERLWIN32GUI_OPT_MULTILINE,
		PERLWIN32GUI_CLS_EDIT |
		PERLWIN32GUI_CLS_RICHEDIT |
		PERLWIN32GUI_CLS_TAB |
		PERLWIN32GUI_CLS_TOOLBAR
	);
	gOptions[i++] = LoadOption("-keepselection",	PERLWIN32GUI_OPT_KEEPSELECTION,
		PERLWIN32GUI_CLS_EDIT | PERLWIN32GUI_CLS_RICHEDIT
	);
	gOptions[i++] = LoadOption("-readonly",			PERLWIN32GUI_OPT_READONLY,
		PERLWIN32GUI_CLS_EDIT | PERLWIN32GUI_CLS_RICHEDIT
	);
	gOptions[i++] = LoadOption("-password",			PERLWIN32GUI_OPT_PASSWORD,
		PERLWIN32GUI_CLS_EDIT | PERLWIN32GUI_CLS_RICHEDIT
	);
	gOptions[i++] = LoadOption("-lowercase",		PERLWIN32GUI_OPT_LOWERCASE,
		PERLWIN32GUI_CLS_EDIT | PERLWIN32GUI_CLS_RICHEDIT
	);
	gOptions[i++] = LoadOption("-uppercase",		PERLWIN32GUI_OPT_UPPERCASE,
		PERLWIN32GUI_CLS_EDIT | PERLWIN32GUI_CLS_RICHEDIT
	);
	gOptions[i++] = LoadOption("-autohscroll",		PERLWIN32GUI_OPT_AUTOHSCROLL,
		PERLWIN32GUI_CLS_EDIT | PERLWIN32GUI_CLS_RICHEDIT
	);
	gOptions[i++] = LoadOption("-autovscroll",		PERLWIN32GUI_OPT_AUTOVSCROLL,
		PERLWIN32GUI_CLS_EDIT | PERLWIN32GUI_CLS_RICHEDIT
	);
	gOptions[i++] = LoadOption("-number",			PERLWIN32GUI_OPT_NUMBER,
		PERLWIN32GUI_CLS_EDIT | PERLWIN32GUI_CLS_RICHEDIT
	);

	// ##########################################
	// Win32::GUI::Button, RadioButton & Checkbox
	// ##########################################
	// -align is handled by Label
	// -bitmap is handled by Label
	gOptions[i++] = LoadOption("-valign",			PERLWIN32GUI_OPT_VALIGN,
		PERLWIN32GUI_CLS_BUTTON | PERLWIN32GUI_CLS_RADIOBUTTON | PERLWIN32GUI_CLS_CHECKBOX
	);
	gOptions[i++] = LoadOption("-ok",				PERLWIN32GUI_OPT_OK,
		PERLWIN32GUI_CLS_BUTTON | PERLWIN32GUI_CLS_RADIOBUTTON | PERLWIN32GUI_CLS_CHECKBOX
	);
	gOptions[i++] = LoadOption("-cancel",			PERLWIN32GUI_OPT_CANCEL,
		PERLWIN32GUI_CLS_BUTTON | PERLWIN32GUI_CLS_RADIOBUTTON | PERLWIN32GUI_CLS_CHECKBOX
	);
	gOptions[i++] = LoadOption("-default",			PERLWIN32GUI_OPT_DEFAULT,
		PERLWIN32GUI_CLS_BUTTON | PERLWIN32GUI_CLS_RADIOBUTTON | PERLWIN32GUI_CLS_CHECKBOX
	);
	gOptions[i++] = LoadOption("-checked",			PERLWIN32GUI_OPT_CHECKED,
		PERLWIN32GUI_CLS_BUTTON | PERLWIN32GUI_CLS_RADIOBUTTON | PERLWIN32GUI_CLS_CHECKBOX
	);

	// #####################################
	// Win32::GUI::Listbox (and Combobox???)
	// #####################################
	gOptions[i++] = LoadOption("-multisel",			PERLWIN32GUI_OPT_MULTISEL,
		PERLWIN32GUI_CLS_LISTBOX
	);
	gOptions[i++] = LoadOption("-sort",				PERLWIN32GUI_OPT_SORT,
		PERLWIN32GUI_CLS_LISTBOX
	);

	// ####################
	// Win32::GUI::TabStrip
	// ####################
	// -multiline is handled by Textfield
	gOptions[i++] = LoadOption("-imagelist",		PERLWIN32GUI_OPT_IMAGELIST,
		PERLWIN32GUI_CLS_TAB |
		PERLWIN32GUI_CLS_TOOLBAR
	);
	gOptions[i++] = LoadOption("-vertical",			PERLWIN32GUI_OPT_VERTICAL,
		PERLWIN32GUI_CLS_TAB
	);
	gOptions[i++] = LoadOption("-bottom",			PERLWIN32GUI_OPT_BOTTOM,
		PERLWIN32GUI_CLS_TAB
	);
	/* TODO: RIGHT!!! */
	gOptions[i++] = LoadOption("-hottrack",			PERLWIN32GUI_OPT_HOTTRACK,
		PERLWIN32GUI_CLS_TAB
	);
	gOptions[i++] = LoadOption("-buttons",			PERLWIN32GUI_OPT_BUTTONS,
		PERLWIN32GUI_CLS_TAB
	);
	gOptions[i++] = LoadOption("-justify",			PERLWIN32GUI_OPT_JUSTIFY,
		PERLWIN32GUI_CLS_TAB
	);
	gOptions[i++] = LoadOption("-flat",				PERLWIN32GUI_OPT_FLAT,
		PERLWIN32GUI_CLS_TAB |
		PERLWIN32GUI_CLS_TOOLBAR
	);
	// ###################
	// Win32::GUI::Toolbar
	// ###################
	// -multiline is handled by Textfield
	// -imagelist is handled by TabStrip
	// -flat is handled by TabStrip
	gOptions[i++] = LoadOption("-nodivider",		PERLWIN32GUI_OPT_NODIVIDER,
		PERLWIN32GUI_CLS_TOOLBAR
	);

	strcat((char *)gpOptions, "-");
	gnOptions = i;
}

int GetOption(char *option, DWORD iClass) {
	int i, iPos;
	char *pPos;
	char *pOption;
	pOption = (char *)safemalloc(strlen(option)+1);
	strcpy(pOption, option);
	strcat(pOption, "-");
	// printf("!XS(GetOption): searching for '%s'...\n", pOption);
	pPos = strstr( (char *)gpOptions, pOption );
	// printf("!XS(GetOption): pPos='%s'\n", pPos);
	safefree(pOption);
	if(pPos != NULL) {
		iPos = pPos - (char *)gpOptions;
		// printf("!XS(GetOption): iPos=%d\n", iPos);
		for(i = 0; i<gnOptions; i++) {
			if(gOptions[i].iPos == iPos) {
				// printf("!XS(GetOption): got iPos of option %d (0x%x)\n", i, gOptions[i].iID);
				if(gOptions[i].dwApply == 0
				||(gOptions[i].dwApply & iClass)) {
					return gOptions[i].iID;
				} else {
					// printf("!XS(GetOption): option does not apply to this iClass\n");
				}
			}
		}
	}
	return 0;
}



    /*
    ###########################################################################
    # (@)INTERNAL:NewParseWindowOptions(sp, mark, ax ,items, from_i, *perlcs)
    */
void NewParseWindowOptions(
    NOTXSPROC
    register SV **sp,
    register SV **mark,
    I32 ax,
    I32 items,
    int from_i,
    LPPERLWIN32GUI_CREATESTRUCT perlcs
) {
    dTHR;
	int i, next_i;
    char * option;
    char * classname;
    SV** stored;
    SV* storing;
    int optionID;
#ifdef PERLWIN32GUI_STRONGDEBUG
    printf("!XS(ParseWindowOptions): from_i=%d\n", from_i);
    printf("!XS(ParseWindowOptions): items=%d\n", items);
#endif
    next_i = -1;
    for(i=from_i; i<items; i++) {
        if(next_i == -1) {
            option = SvPV_nolen(ST(i));
			optionID = GetOption( option, perlcs->iClass );
#ifdef PERLWIN32GUI_STRONGDEBUG
            printf("!XS(ParseWindowOptions): got option '%s', ID=0x%x\n", option, optionID);
#endif
			if(optionID) {
				switch(optionID) {
				case PERLWIN32GUI_OPT_NAME:
					next_i = i + 1;
					perlcs->szWindowName = SvPV_nolen(ST(next_i));
					break;
				case PERLWIN32GUI_OPT_TEXT:
					next_i = i + 1;
					perlcs->cs.lpszName = (LPCTSTR) SvPV_nolen(ST(next_i));
					break;
            	case PERLWIN32GUI_OPT_LEFT:
					next_i = i + 1;
					perlcs->cs.x = (int) SvIV(ST(next_i));
					break;
				case PERLWIN32GUI_OPT_TOP:
					next_i = i + 1;
					perlcs->cs.y = (int) SvIV(ST(next_i));
					break;
				case PERLWIN32GUI_OPT_WIDTH:
					next_i = i + 1;
					perlcs->cs.cx = (int) SvIV(ST(next_i));
					break;
				case PERLWIN32GUI_OPT_HEIGHT:
					next_i = i + 1;
					perlcs->cs.cy = (int) SvIV(ST(next_i));
					break;
				case PERLWIN32GUI_OPT_POS:
					next_i = i + 1;
					if(SvROK(ST(next_i)) && SvTYPE(SvRV(ST(next_i))) == SVt_PVAV) {
						SV** t;
						t = av_fetch((AV*)SvRV(ST(next_i)), 0, 0);
						if(t != NULL) {
							perlcs->cs.x = (int) SvIV(*t);
						}
						t = av_fetch((AV*)SvRV(ST(next_i)), 1, 0);
						if(t != NULL) {
							perlcs->cs.y = (int) SvIV(*t);
						}
					} else {
						if(PL_dowarn) {
							warn("Win32::GUI: Argument to -pos is not an array reference!");
						}
					}
					break;
				case PERLWIN32GUI_OPT_SIZE:
					next_i = i + 1;
					if(SvROK(ST(next_i)) && SvTYPE(SvRV(ST(next_i))) == SVt_PVAV) {
						SV** t;
						t = av_fetch((AV*)SvRV(ST(next_i)), 0, 0);
						if(t != NULL) {
							perlcs->cs.cx = (int) SvIV(*t);
						}
						t = av_fetch((AV*)SvRV(ST(next_i)), 1, 0);
						if(t != NULL) {
							perlcs->cs.cy = (int) SvIV(*t);
						}
					} else {
						if(PL_dowarn) {
							warn("Win32::GUI: Argument to -size is not an array reference!");
						}
					}
					break;
				case PERLWIN32GUI_OPT_CLASS:
					next_i = i + 1;
					perlcs->cs.lpszClass = (LPCTSTR) classname_From(NOTXSCALL ST(next_i));
					break;
				case PERLWIN32GUI_OPT_STYLE: /* DEPRECATED */
					next_i = i + 1;
					perlcs->cs.style = (DWORD) SvIV(ST(next_i));
					if(PL_dowarn) {
						warn("Win32::GUI: the -style option is deprecated!");
					}
					break;
				case PERLWIN32GUI_OPT_EXSTYLE: /* DEPRECATED */
					next_i = i + 1;
					perlcs->cs.dwExStyle = (DWORD) SvIV(ST(next_i));
					if(PL_dowarn) {
						warn("Win32::GUI: the -exstyle option is deprecated!");
					}
					break;
				case PERLWIN32GUI_OPT_PUSHSTYLE:
					next_i = i + 1;
					perlcs->cs.style |= (DWORD) SvIV(ST(next_i));
					break;
				case PERLWIN32GUI_OPT_POPSTYLE:
					next_i = i + 1;
					perlcs->cs.style ^= (DWORD) SvIV(ST(next_i));
					break;
				case PERLWIN32GUI_OPT_PUSHEXSTYLE:
					next_i = i + 1;
					perlcs->cs.dwExStyle |= (DWORD) SvIV(ST(next_i));
					break;
				case PERLWIN32GUI_OPT_POPEXSTYLE:
					next_i = i + 1;
					perlcs->cs.dwExStyle ^= (DWORD) SvIV(ST(next_i));
					break;
				case PERLWIN32GUI_OPT_PARENT:
					next_i = i + 1;
					perlcs->cs.hwndParent = (HWND) handle_From(NOTXSCALL ST(next_i));
					perlcs->hvParent = (HV*) SvRV(ST(next_i));
					break;
				case PERLWIN32GUI_OPT_MENU:
					next_i = i + 1;
					perlcs->cs.hMenu = (HMENU) handle_From(NOTXSCALL ST(next_i));
					break;
				case PERLWIN32GUI_OPT_INSTANCE: /* DEPRECATED */
					next_i = i + 1;
					perlcs->cs.hInstance = (HINSTANCE) SvIV(ST(next_i));
					break;
				case PERLWIN32GUI_OPT_FONT:
					next_i = i + 1;
					perlcs->hFont = (HFONT) handle_From(NOTXSCALL ST(next_i));
					break;
				case PERLWIN32GUI_OPT_VISIBLE:
					next_i = i + 1;
					SwitchFlag(perlcs->cs.style, WS_VISIBLE, SvIV(ST(next_i)));
					break;
				case PERLWIN32GUI_OPT_DISABLED:
					next_i = i + 1;
					SwitchFlag(perlcs->cs.style, WS_DISABLED, SvIV(ST(next_i)));
					break;
				case PERLWIN32GUI_OPT_GROUP:
					next_i = i + 1;
					SwitchFlag(perlcs->cs.style, WS_GROUP, SvIV(ST(next_i)));
					break;
				case PERLWIN32GUI_OPT_TABSTOP:
					next_i = i + 1;
					SwitchFlag(perlcs->cs.style, WS_TABSTOP, SvIV(ST(next_i)));
					break;
				case PERLWIN32GUI_OPT_FOREGROUND:
					next_i = i + 1;
					perlcs->clrForeground = SvCOLORREF(NOTXSCALL ST(next_i));
					storing = newSViv((long) perlcs->clrForeground);
					stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-foreground", 11, storing, 0);
					break;
				case PERLWIN32GUI_OPT_BACKGROUND:
					next_i = i + 1;
					perlcs->clrBackground = SvCOLORREF(NOTXSCALL ST(next_i));
					{
						LOGBRUSH lb;
						ZeroMemory(&lb, sizeof(LOGBRUSH));
						lb.lbStyle = BS_SOLID;
						lb.lbColor = perlcs->clrBackground;
						if(perlcs->hBackgroundBrush != NULL) {
							DeleteObject((HGDIOBJ) perlcs->hBackgroundBrush);
						}
						perlcs->hBackgroundBrush = CreateBrushIndirect(&lb);
					}
					storing = newSViv((long) perlcs->clrBackground);
					stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-background", 11, storing, 0);
					storing = newSViv((long) perlcs->hBackgroundBrush);
					stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-backgroundbrush", 16, storing, 0);
					break;
				case PERLWIN32GUI_OPT_HSCROLL:
					next_i = i + 1;
					SwitchFlag(perlcs->cs.style, WS_HSCROLL, SvIV(ST(next_i)));
					break;
				case PERLWIN32GUI_OPT_VSCROLL:
					next_i = i + 1;
					SwitchFlag(perlcs->cs.style, WS_VSCROLL, SvIV(ST(next_i)));
					break;
				case PERLWIN32GUI_OPT_TIP:
					next_i = i + 1;
					perlcs->szTip = SvPV_nolen(ST(next_i));
					break;
				case PERLWIN32GUI_OPT_CONTAINER:
					next_i = i + 1;
					SwitchFlag(perlcs->dwPlStyle, PERLWIN32GUI_CONTAINER, SvIV(ST(next_i)));
					break;
				case PERLWIN32GUI_OPT_EVENTS:
					HV* hash;
					SV* val;
					SV* newval;
					char* key;
					I32 keylen;
					next_i = i + 1;
					perlcs->hvEvents = newHV();
					hash = (HV*) SvRV(ST(next_i));
					perlcs->dwEventMask = 0;
					hv_iterinit( hash );
					while ( (val = hv_iternextsv( hash, &key, &keylen )) ) {
#ifdef PERLWIN32GUI_STRONGDEBUG
						printf("!XS(ParseWindowOptions) got NEM key '%s'\n", key);
#endif
						if(strcmp(key, "MouseMove") == 0) {
							SwitchFlag(perlcs->dwEventMask, PERLWIN32GUI_NEM_MOUSEMOVE, 1);
						} else if(strcmp(key, "MouseDown") == 0) {
							SwitchFlag(perlcs->dwEventMask, PERLWIN32GUI_NEM_MOUSEDOWN, 1);
						} else if(strcmp(key, "MouseUp") == 0) {
							SwitchFlag(perlcs->dwEventMask, PERLWIN32GUI_NEM_MOUSEUP, 1);
						} else if(strcmp(key, "KeyDown") == 0) {
							SwitchFlag(perlcs->dwEventMask, PERLWIN32GUI_NEM_KEYDOWN, 1);
						} else if(strcmp(key, "KeyUp") == 0) {
							SwitchFlag(perlcs->dwEventMask, PERLWIN32GUI_NEM_KEYUP, 1);
						} else if(strcmp(key, "Click") == 0) {
							SwitchFlag(perlcs->dwEventMask, PERLWIN32GUI_NEM_CLICK, 1);
							SwitchFlag(perlcs->dwPlStyle, PERLWIN32GUI_NEM_PARENT, 1);
						} else {
							if(PL_dowarn) {
								warn("Win32::GUI: Unrecognized event name '%s' in -events!", key);
							}
						}
						newval = newSVsv(val);
						hv_store(perlcs->hvEvents, key, keylen, newval, 0);
					}
#ifdef PERLWIN32GUI_STRONGDEBUG
					printf("!XS(ParseWindowOptions) NEM mask is %x\n", perlcs->dwEventMask);
#endif
					SwitchFlag(perlcs->dwPlStyle, PERLWIN32GUI_NEM, 1);
					break;
				}
				// ######################
				// class-specific parsing
				// ######################
				switch(perlcs->iClass) {
				// ##############################
				// Win32::GUI::Window & DialogBox
				// ##############################
				case PERLWIN32GUI_CLS_WINDOW:
				case PERLWIN32GUI_CLS_DIALOG:
					switch(optionID) {
					case PERLWIN32GUI_OPT_MINSIZE:
						next_i = i + 1;
						if(SvROK(ST(next_i)) && SvTYPE(SvRV(ST(next_i))) == SVt_PVAV) {
							SV** t;
							t = av_fetch((AV*)SvRV(ST(next_i)), 0, 0);
							if(t != NULL) {
								perlcs->iMinWidth = (int) SvIV(*t);
								storing = newSViv((LONG) SvIV(*t));
								stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-minwidth", 9, storing, 0);
							}
							t = av_fetch((AV*)SvRV(ST(next_i)), 1, 0);
							if(t != NULL) {
								perlcs->iMinHeight = (int) SvIV(*t);
								storing = newSViv((LONG) SvIV(*t));
								stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-minheight", 10, storing, 0);
							}
						} else {
							if(PL_dowarn)
								warn("Win32::GUI: Argument to -minsize is not an array reference!");
						}
						break;
					case PERLWIN32GUI_OPT_MAXSIZE:
						next_i = i + 1;
						if(SvROK(ST(next_i)) && SvTYPE(SvRV(ST(next_i))) == SVt_PVAV) {
							SV** t;
							t = av_fetch((AV*)SvRV(ST(next_i)), 0, 0);
							if(t != NULL) {
								perlcs->iMaxWidth = (int) SvIV(*t);
								storing = newSViv((LONG) SvIV(*t));
								stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-maxwidth", 9, storing, 0);
							}
							t = av_fetch((AV*)SvRV(ST(next_i)), 1, 0);
							if(t != NULL) {
								perlcs->iMaxHeight = (int) SvIV(*t);
								storing = newSViv((LONG) SvIV(*t));
								stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-maxheight", 10, storing, 0);
							}
						} else {
							if(PL_dowarn)
								warn("Win32::GUI: Argument to -maxsize is not an array reference!");
						}
						break;
					case PERLWIN32GUI_OPT_MINWIDTH:
						next_i = i + 1;
						perlcs->iMinWidth = (int) SvIV(ST(next_i));
						storing = newSViv((LONG) SvIV(ST(next_i)));
						stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-minwidth", 9, storing, 0);
						break;
					case PERLWIN32GUI_OPT_MINHEIGHT:
						next_i = i + 1;
						perlcs->iMinHeight = (int) SvIV(ST(next_i));
						storing = newSViv((LONG) SvIV(ST(next_i)));
						stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-minheight", 10, storing, 0);
						break;
					case PERLWIN32GUI_OPT_MAXWIDTH:
						next_i = i + 1;
						perlcs->iMaxWidth = (int) SvIV(ST(next_i));
						storing = newSViv((LONG) SvIV(ST(next_i)));
						stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-maxwidth", 9, storing, 0);
						break;
					case PERLWIN32GUI_OPT_MAXHEIGHT:
						next_i = i + 1;
						perlcs->iMaxHeight = (int) SvIV(ST(next_i));
						storing = newSViv((LONG) SvIV(ST(next_i)));
						stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-maxheight", 10, storing, 0);
						break;
					case PERLWIN32GUI_OPT_TOPMOST:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.dwExStyle, WS_EX_TOPMOST, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_CONTROLPARENT:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.dwExStyle, WS_EX_CONTROLPARENT, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_MAXIMIZEBOX:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, WS_MAXIMIZEBOX, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_MINIMIZEBOX:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, WS_MINIMIZEBOX, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_RESIZABLE:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, WS_THICKFRAME, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_SYSMENU:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, WS_SYSMENU, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_HELPBOX:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.dwExStyle, WS_EX_CONTEXTHELP, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_ACCEL:
						next_i = i + 1;
						perlcs->hAcc = (HACCEL) handle_From(NOTXSCALL ST(next_i));
						storing = newSViv((LONG) handle_From(NOTXSCALL ST(next_i)));
						stored = hv_store_mg(NOTXSCALL perlcs->hvSelf, "-accel", 6, storing, 0);
						break;
					}
					break;

				// #################
				// Win32::GUI::Label
				// #################
				case PERLWIN32GUI_CLS_STATIC:
					switch(optionID) {
					case PERLWIN32GUI_OPT_ALIGN:
						next_i = i + 1;
						if(stricmp(SvPV_nolen(ST(next_i)), "left") == 0) {
							SwitchFlag(perlcs->cs.style, SS_LEFT, 1);
							SwitchFlag(perlcs->cs.style, SS_CENTER, 0);
							SwitchFlag(perlcs->cs.style, SS_RIGHT, 0);
						} else if(stricmp(SvPV_nolen(ST(next_i)), "center") == 0) {
							SwitchFlag(perlcs->cs.style, SS_LEFT, 0);
							SwitchFlag(perlcs->cs.style, SS_CENTER, 1);
							SwitchFlag(perlcs->cs.style, SS_RIGHT, 0);
						} else if(stricmp(SvPV_nolen(ST(next_i)), "right") == 0) {
							SwitchFlag(perlcs->cs.style, SS_LEFT, 0);
							SwitchFlag(perlcs->cs.style, SS_CENTER, 0);
							SwitchFlag(perlcs->cs.style, SS_RIGHT, 1);
						} else {
							if(PL_dowarn) warn("Win32::GUI: Invalid value for -align!");
						}
						break;
					case PERLWIN32GUI_OPT_BITMAP:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, SS_BITMAP, 1);
						perlcs->hImageList = (HIMAGELIST) handle_From(NOTXSCALL ST(next_i));
						break;
					case PERLWIN32GUI_OPT_TRUNCATE:
						next_i = i + 1;
						if(stricmp(SvPV_nolen(ST(next_i)), "path") == 0) {
							SwitchFlag(perlcs->cs.style, SS_PATHELLIPSIS, 1);
							SwitchFlag(perlcs->cs.style, SS_ENDELLIPSIS, 0);
							SwitchFlag(perlcs->cs.style, SS_WORDELLIPSIS, 0);
						} else if(stricmp(SvPV_nolen(ST(next_i)), "word") == 0) {
							SwitchFlag(perlcs->cs.style, SS_PATHELLIPSIS, 0);
							SwitchFlag(perlcs->cs.style, SS_ENDELLIPSIS, 0);
							SwitchFlag(perlcs->cs.style, SS_WORDELLIPSIS, 1);
						} else if(SvIV(ST(next_i))) {
							SwitchFlag(perlcs->cs.style, SS_PATHELLIPSIS, 0);
							SwitchFlag(perlcs->cs.style, SS_ENDELLIPSIS, 1);
							SwitchFlag(perlcs->cs.style, SS_WORDELLIPSIS, 0);
						} else {
							SwitchFlag(perlcs->cs.style, SS_PATHELLIPSIS, 0);
							SwitchFlag(perlcs->cs.style, SS_ENDELLIPSIS, 0);
							SwitchFlag(perlcs->cs.style, SS_WORDELLIPSIS, 0);
						}
						break;
					case PERLWIN32GUI_OPT_FRAME:
						next_i = i + 1;
						if(stricmp(SvPV_nolen(ST(next_i)), "black") == 0) {
							SwitchFlag(perlcs->cs.style, SS_BLACKFRAME, 1);
							SwitchFlag(perlcs->cs.style, SS_GRAYFRAME, 0);
							SwitchFlag(perlcs->cs.style, SS_WHITEFRAME, 0);
							SwitchFlag(perlcs->cs.style, SS_ETCHEDFRAME, 0);
						} else if(stricmp(SvPV_nolen(ST(next_i)), "gray") == 0) {
							SwitchFlag(perlcs->cs.style, SS_BLACKFRAME, 0);
							SwitchFlag(perlcs->cs.style, SS_GRAYFRAME, 1);
							SwitchFlag(perlcs->cs.style, SS_WHITEFRAME, 0);
							SwitchFlag(perlcs->cs.style, SS_ETCHEDFRAME, 0);
						} else if(stricmp(SvPV_nolen(ST(next_i)), "white") == 0) {
							SwitchFlag(perlcs->cs.style, SS_BLACKFRAME, 0);
							SwitchFlag(perlcs->cs.style, SS_GRAYFRAME, 0);
							SwitchFlag(perlcs->cs.style, SS_WHITEFRAME, 1);
							SwitchFlag(perlcs->cs.style, SS_ETCHEDFRAME, 0);
						} else if(stricmp(SvPV_nolen(ST(next_i)), "etched") == 0) {
							SwitchFlag(perlcs->cs.style, SS_BLACKFRAME, 0);
							SwitchFlag(perlcs->cs.style, SS_GRAYFRAME, 0);
							SwitchFlag(perlcs->cs.style, SS_WHITEFRAME, 0);
							SwitchFlag(perlcs->cs.style, SS_ETCHEDFRAME, 1);
						} else {
							SwitchFlag(perlcs->cs.style, SS_BLACKFRAME, 0);
							SwitchFlag(perlcs->cs.style, SS_GRAYFRAME, 0);
							SwitchFlag(perlcs->cs.style, SS_WHITEFRAME, 0);
							SwitchFlag(perlcs->cs.style, SS_ETCHEDFRAME, 0);
						}
						break;
					case PERLWIN32GUI_OPT_FILL:
						next_i = i + 1;
						if(stricmp(SvPV_nolen(ST(next_i)), "black") == 0) {
							SwitchFlag(perlcs->cs.style, SS_BLACKRECT, 1);
							SwitchFlag(perlcs->cs.style, SS_GRAYRECT, 0);
							SwitchFlag(perlcs->cs.style, SS_WHITERECT, 0);
						} else if(stricmp(SvPV_nolen(ST(next_i)), "gray") == 0) {
							SwitchFlag(perlcs->cs.style, SS_BLACKRECT, 0);
							SwitchFlag(perlcs->cs.style, SS_GRAYRECT, 1);
							SwitchFlag(perlcs->cs.style, SS_WHITERECT, 0);
						} else if(stricmp(SvPV_nolen(ST(next_i)), "white") == 0) {
							SwitchFlag(perlcs->cs.style, SS_BLACKRECT, 0);
							SwitchFlag(perlcs->cs.style, SS_GRAYRECT, 0);
							SwitchFlag(perlcs->cs.style, SS_WHITERECT, 1);
						} else if(stricmp(SvPV_nolen(ST(next_i)), "etched") == 0) {
							SwitchFlag(perlcs->cs.style, SS_BLACKRECT, 0);
							SwitchFlag(perlcs->cs.style, SS_GRAYRECT, 0);
							SwitchFlag(perlcs->cs.style, SS_WHITERECT, 0);
						} else {
							SwitchFlag(perlcs->cs.style, SS_BLACKRECT, 0);
							SwitchFlag(perlcs->cs.style, SS_GRAYRECT, 0);
							SwitchFlag(perlcs->cs.style, SS_WHITERECT, 0);
						}
						break;
					case PERLWIN32GUI_OPT_SUNKEN:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, SS_SUNKEN, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_WRAP:
						next_i = i + 1;
						if(SvIV(ST(next_i))) {
							SwitchFlag(perlcs->cs.style, SS_LEFTNOWORDWRAP, 0);
						} else {
							SwitchFlag(perlcs->cs.style, SS_LEFTNOWORDWRAP, 1);
						}
						break;
					case PERLWIN32GUI_OPT_NOTIFY:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, SS_NOTIFY, SvIV(ST(next_i)));
						break;
					}
					break;

				// ################################
				// Win32::GUI::Textfield & RichEdit
				// ################################
				case PERLWIN32GUI_CLS_EDIT:
				case PERLWIN32GUI_CLS_RICHEDIT:
					switch(optionID) {
					case PERLWIN32GUI_OPT_ALIGN:
						next_i = i + 1;
						if(stricmp(SvPV_nolen(ST(next_i)), "left") == 0) {
							SwitchFlag(perlcs->cs.style, ES_LEFT, 1);
							SwitchFlag(perlcs->cs.style, ES_CENTER, 0);
							SwitchFlag(perlcs->cs.style, ES_RIGHT, 0);
						} else if(stricmp(SvPV_nolen(ST(next_i)), "center") == 0) {
							SwitchFlag(perlcs->cs.style, ES_LEFT, 0);
							SwitchFlag(perlcs->cs.style, ES_CENTER, 1);
							SwitchFlag(perlcs->cs.style, ES_RIGHT, 0);
						} else if(stricmp(SvPV_nolen(ST(next_i)), "right") == 0) {
							SwitchFlag(perlcs->cs.style, ES_LEFT, 0);
							SwitchFlag(perlcs->cs.style, ES_CENTER, 0);
							SwitchFlag(perlcs->cs.style, ES_RIGHT, 1);
						} else {
							if(PL_dowarn) warn("Win32::GUI: Invalid value for -align!");
						}
						break;
					case PERLWIN32GUI_OPT_MULTILINE:
						next_i = i + 1;
						if(SvIV(ST(next_i))) {
							SwitchFlag(perlcs->cs.style, ES_MULTILINE, 1);
							SwitchFlag(perlcs->cs.style, ES_AUTOHSCROLL, 0);
						} else {
							SwitchFlag(perlcs->cs.style, ES_MULTILINE, 0);
							SwitchFlag(perlcs->cs.style, ES_AUTOHSCROLL, 1);
						}
						break;
					case PERLWIN32GUI_OPT_KEEPSELECTION:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, ES_NOHIDESEL, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_READONLY:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, ES_READONLY, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_PASSWORD:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, ES_PASSWORD, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_LOWERCASE:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, ES_LOWERCASE, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_UPPERCASE:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, ES_UPPERCASE, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_AUTOHSCROLL:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, ES_AUTOHSCROLL, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_AUTOVSCROLL:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, ES_AUTOVSCROLL, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_NUMBER:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, ES_NUMBER, SvIV(ST(next_i)));
						break;
					}
					break;

				// ##########################################
				// Win32::GUI::Button, RadioButton & Checkbox
				// ##########################################
				case PERLWIN32GUI_CLS_BUTTON:
				case PERLWIN32GUI_CLS_RADIOBUTTON:
				case PERLWIN32GUI_CLS_CHECKBOX:
					switch(optionID) {
					case PERLWIN32GUI_OPT_ALIGN:
						next_i = i + 1;
						if(stricmp(SvPV_nolen(ST(next_i)), "left") == 0) {
							SwitchFlag(perlcs->cs.style, BS_LEFT, 1);
							SwitchFlag(perlcs->cs.style, BS_CENTER, 0);
							SwitchFlag(perlcs->cs.style, BS_RIGHT, 0);
						} else if(stricmp(SvPV_nolen(ST(next_i)), "center") == 0) {
							SwitchFlag(perlcs->cs.style, BS_LEFT, 0);
							SwitchFlag(perlcs->cs.style, BS_CENTER, 1);
							SwitchFlag(perlcs->cs.style, BS_RIGHT, 0);
						} else if(stricmp(SvPV_nolen(ST(next_i)), "right") == 0) {
							SwitchFlag(perlcs->cs.style, BS_LEFT, 0);
							SwitchFlag(perlcs->cs.style, BS_CENTER, 0);
							SwitchFlag(perlcs->cs.style, BS_RIGHT, 1);
						} else {
							if(PL_dowarn) warn("Win32::GUI: Invalid value for -align!");
						}
						break;
					case PERLWIN32GUI_OPT_BITMAP:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, BS_BITMAP, 1);
						perlcs->hImageList = (HIMAGELIST) handle_From(NOTXSCALL ST(next_i));
						break;
					case PERLWIN32GUI_OPT_VALIGN:
						next_i = i + 1;
						if(stricmp(SvPV_nolen(ST(next_i)), "top") == 0) {
							SwitchFlag(perlcs->cs.style, BS_TOP, 1);
							SwitchFlag(perlcs->cs.style, BS_VCENTER, 0);
							SwitchFlag(perlcs->cs.style, BS_BOTTOM, 0);
						} else if(stricmp(SvPV_nolen(ST(next_i)), "center") == 0) {
							SwitchFlag(perlcs->cs.style, BS_TOP, 0);
							SwitchFlag(perlcs->cs.style, BS_VCENTER, 1);
							SwitchFlag(perlcs->cs.style, BS_BOTTOM, 0);
						} else if(stricmp(SvPV_nolen(ST(next_i)), "bottom") == 0) {
							SwitchFlag(perlcs->cs.style, BS_TOP, 0);
							SwitchFlag(perlcs->cs.style, BS_VCENTER, 0);
							SwitchFlag(perlcs->cs.style, BS_BOTTOM, 1);
						} else {
							if(PL_dowarn) warn("Win32::GUI: Invalid value for -valign!");
						}
						break;
					case PERLWIN32GUI_OPT_OK:
						next_i = i + 1;
						if(SvIV(ST(next_i)) != 0) {
							perlcs->cs.hMenu = (HMENU) IDOK;
						}
						break;
					case PERLWIN32GUI_OPT_CANCEL:
						next_i = i + 1;
						if(SvIV(ST(next_i)) != 0) {
							perlcs->cs.hMenu = (HMENU) IDCANCEL;
						}
						break;
					case PERLWIN32GUI_OPT_DEFAULT:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, BS_DEFPUSHBUTTON, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_CHECKED:
						next_i = i + 1;
						SwitchFlag(perlcs->dwPlStyle, PERLWIN32GUI_CHECKED, SvIV(ST(next_i)));
						SwitchFlag(perlcs->dwPlStyle, PERLWIN32GUI_SEENCHECKED, 1);
						break;
					}
					break;

				// #####################################
				// Win32::GUI::Listbox (and Combobox???)
				// #####################################
				case PERLWIN32GUI_CLS_LISTBOX:
					switch(optionID) {
					case PERLWIN32GUI_OPT_MULTISEL:
						next_i = i + 1;
						if(SvIV(ST(next_i)) == 0) {
							SwitchFlag(perlcs->cs.style, LBS_MULTIPLESEL, 0);
							SwitchFlag(perlcs->cs.style, LBS_EXTENDEDSEL, 0);
						} else if(SvIV(ST(next_i)) == 1) {
							SwitchFlag(perlcs->cs.style, LBS_MULTIPLESEL, 1);
							SwitchFlag(perlcs->cs.style, LBS_EXTENDEDSEL, 0);
						} else if(SvIV(ST(next_i)) == 2) {
							SwitchFlag(perlcs->cs.style, LBS_MULTIPLESEL, 1);
							SwitchFlag(perlcs->cs.style, LBS_EXTENDEDSEL, 1);
						} else {
							if(PL_dowarn) warn("Win32::GUI: Invalid value for -multisel!");
						}
						break;
					case PERLWIN32GUI_OPT_SORT:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, LBS_SORT, SvIV(ST(next_i)));
						break;
					}
					break;

				// ####################
				// Win32::GUI::TabStrip
				// ####################
				case PERLWIN32GUI_CLS_TAB:
					switch(optionID) {
					case PERLWIN32GUI_OPT_MULTILINE:
						SwitchFlag(perlcs->cs.style, TCS_MULTILINE, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_IMAGELIST:
						next_i = i + 1;
						perlcs->hImageList = (HIMAGELIST) handle_From(NOTXSCALL ST(next_i));
						break;
					case PERLWIN32GUI_OPT_VERTICAL:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, TCS_VERTICAL, SvIV(ST(next_i)));
						SwitchFlag(perlcs->cs.style, TCS_MULTILINE, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_BOTTOM:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, TCS_BOTTOM, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_TABRIGHT:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, TCS_RIGHT, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_HOTTRACK:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, TCS_HOTTRACK, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_BUTTONS:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, TCS_BUTTONS, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_JUSTIFY:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, TCS_RIGHTJUSTIFY, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_FLAT:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, TCS_FLATBUTTONS, SvIV(ST(next_i)));
						break;
					}
					break;

				// ###################
				// Win32::GUI::Toolbar
				// ###################
				case PERLWIN32GUI_CLS_TOOLBAR:
					switch(optionID) {
					case PERLWIN32GUI_OPT_MULTILINE:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, TBSTYLE_WRAPABLE, SvIV(ST(next_i)));
					case PERLWIN32GUI_OPT_IMAGELIST:
						next_i = i + 1;
						perlcs->hImageList = (HIMAGELIST) handle_From(NOTXSCALL ST(next_i));
						break;
					case PERLWIN32GUI_OPT_NODIVIDER:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, CCS_NODIVIDER, SvIV(ST(next_i)));
						break;
					case PERLWIN32GUI_OPT_FLAT:
						next_i = i + 1;
						SwitchFlag(perlcs->cs.style, TBSTYLE_FLAT, SvIV(ST(next_i)));
						break;
					}
					break;

				}
			} else {
				if(PL_dowarn) {
					warn("Win32::GUI: Unrecognized option: '%s'", option);
				}
				next_i = 0;
			}
        } else {
            next_i = -1;
        }
    }
}



